//---------------------------------------------------------------------------
//
//	X68000 EMULATOR "XM6" UTILITY
//
//	Copyright (C) 2001-2006 ohD(ytanaka@ipc-tokai.or.jp)
//	[ CG-ROM ]
//
//	CG-ROM̍ASÝAJĂWinX68k̃\[XQlɂĂ܂B
//	  ASYlāE쐬ꂽA񂶂厁E䂢Ɋӂ܂B
//
//---------------------------------------------------------------------------

#include "os.h"
#include "xm6util.h"
#include "filepath.h"
#include "fileio.h"
#include "cgrom.h"

#if defined(_WIN32)

//===========================================================================
//
//	CG-ROM
//
//===========================================================================

//---------------------------------------------------------------------------
//
//	RXgN^
//
//---------------------------------------------------------------------------
CGROM::CGROM()
{
	int nSize;

	// foCXReLXgErbg}bvEtHg
	m_hDC = NULL;
	m_hDIBitmap = NULL;
	m_hBitmapBk = NULL;
	m_hFontBk = NULL;
	m_pBits = NULL;

	// tHgz
	for (nSize=0; nSize<SizeMax; nSize++) {
		m_hGothic[nSize] = NULL;
		m_hMincho[nSize] = NULL;
	}

	// tHgl[
	memset(m_szGothicName, 0, sizeof(m_szGothicName));
	memset(m_szMinchoName, 0, sizeof(m_szMinchoName));

	// f[^obt@
	m_pBuf = NULL;
	m_pTemp = NULL;
}

//---------------------------------------------------------------------------
//
//	fXgN^
//
//---------------------------------------------------------------------------
CGROM::~CGROM()
{
	ASSERT(!m_hDC);
	ASSERT(!m_hDIBitmap);
	ASSERT(!m_pBits);
	ASSERT(!m_pBuf);
	ASSERT(!m_pTemp);
}

//---------------------------------------------------------------------------
//
//	
//
//---------------------------------------------------------------------------
BOOL FASTCALL CGROM::Init()
{
	HDC hDC;
	BYTE bmpinfo[sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 2];
	BITMAPINFOHEADER *pbmi;
	RGBQUAD *prgbq;
	LOGFONT lf;
	int nSize;

	ASSERT(this);
	ASSERT(!m_pBuf);

	// SVbNtHgEtHg݂邩
	if (!IsInstalled()) {
		return FALSE;
	}

#if defined(UNICODE)
	// {łȂ
	if (!::IsJapanese()) {
		// CP932T|[gĂ邩
		if (!::Support932()) {
			return FALSE;
		}
	}
#endif	// UNICODE

	// obt@m(ROMf[^)
	try {
		m_pBuf = new BYTE[ 0xc0000 ];
	}
	catch (...) {
		m_pBuf = NULL;
	}
	if (!m_pBuf) {
		return FALSE;
	}

	// obt@m(e|)
	try {
		m_pTemp = new BYTE[ 0xc0000 ];
	}
	catch (...) {
		m_pTemp = NULL;
	}
	if (!m_pTemp) {
		return FALSE;
	}

	// DC쐬
	hDC = ::GetDC(AfxGetApp()->m_pMainWnd->m_hWnd);
	ASSERT(hDC);

	// DIBZNV쐬(32x32Œ)
	memset(bmpinfo, 0, sizeof(bmpinfo));
	pbmi = (BITMAPINFOHEADER*)&bmpinfo[0];
	pbmi->biSize = sizeof(BITMAPINFOHEADER);
	pbmi->biWidth = 32;
	pbmi->biHeight = -32;
	pbmi->biPlanes = 1;
	pbmi->biBitCount = 1;
	pbmi->biCompression = BI_RGB;
	pbmi->biSizeImage = (32 / 8) * 32;
	prgbq = (RGBQUAD*)&bmpinfo[sizeof(BITMAPINFOHEADER)];
	prgbq[0].rgbBlue = 0;
	prgbq[0].rgbGreen = 0;
	prgbq[0].rgbRed = 0;
	prgbq[1].rgbBlue = 0xff;
	prgbq[1].rgbRed = 0xff;
	prgbq[1].rgbGreen = 0xff;
	m_hDIBitmap = ::CreateDIBSection(hDC, (CONST BITMAPINFO*)&bmpinfo[0],
									DIB_RGB_COLORS, (void **)&m_pBits, NULL, 0);
	if (!m_hDIBitmap) {
		::ReleaseDC(AfxGetApp()->m_pMainWnd->m_hWnd, hDC);
		return FALSE;
	}

	// DC쐬(DC͂̂Ă)
	m_hDC = ::CreateCompatibleDC(hDC);
	ASSERT(m_hDC);
	::ReleaseDC(AfxGetApp()->m_pMainWnd->m_hWnd, hDC);
	hDC = NULL;

	// rbg}bv蓖āAFݒ肷
	m_hBitmapBk = (HBITMAP)::SelectObject(m_hDC, m_hDIBitmap);
	ASSERT(m_hBitmapBk);
	::SetDIBColorTable(m_hDC, 0, 2, (CONST RGBQUAD*)&bmpinfo[sizeof(BITMAPINFOHEADER)]);

	// tHg쐬(2ށ~TCY4)
	for (nSize=0; nSize<SizeMax; nSize++) {
		// SVbN
		InitLogFont(nSize, &lf, m_szGothicName);
		m_hGothic[nSize] = ::CreateFontIndirect(&lf);
		ASSERT(m_hGothic[nSize]);

		// 
		InitLogFont(nSize, &lf, m_szMinchoName);
		m_hMincho[nSize] = ::CreateFontIndirect(&lf);
		ASSERT(m_hMincho[nSize]);
	}

	// ŏɁASVbNZbgĂ(ۂ́Aǂł悢)
	m_hFontBk = (HFONT)::SelectObject(m_hDC, m_hGothic[0]);
	ASSERT(m_hFontBk);

	// eLXgFw
	::SetTextColor(m_hDC, RGB(255, 255, 255));
	::SetBkColor(m_hDC, RGB(0, 0, 0));

	// (DC쐬Arbg}bvEtHg蓖Ă)
	return TRUE;
}

//---------------------------------------------------------------------------
//
//	LOGFONT\̏
//
//---------------------------------------------------------------------------
void FASTCALL CGROM::InitLogFont(int nSize, LOGFONT *lf, LPCTSTR lpszFaceName)
{
	ASSERT(this);
	ASSERT(nSize >= 0);
	ASSERT(nSize < SizeMax);
	ASSERT(lf);
	ASSERT(lpszFaceName);
	ASSERT(_tcslen(lpszFaceName) > 0);

	// ܂NA
	memset(lf, 0, sizeof(LOGFONT));

	// TCY
	switch ((FontSize)nSize) {
		// 6x12
		case Size6x12:
			lf->lfWidth = 6;
			lf->lfHeight = 12;
			break;

		// 8x16
		case Size8x16:
			lf->lfWidth = 8;
			lf->lfHeight = 16;
			break;

		// 6x24
		case Size6x24:
			lf->lfWidth = 6;
			lf->lfHeight = 24;
			break;

		// 12x24
		case Size12x24:
			lf->lfWidth = 12;
			lf->lfHeight = 24;
			break;

		default:
			ASSERT(FALSE);
			break;
	}

	// ̑Zbg
	lf->lfEscapement = 0;
	lf->lfOrientation = 0;
	lf->lfWeight = FW_DONTCARE;
	lf->lfItalic = FALSE;
	lf->lfUnderline = FALSE;
	lf->lfStrikeOut = FALSE;
	lf->lfCharSet = SHIFTJIS_CHARSET;
	lf->lfOutPrecision = OUT_DEFAULT_PRECIS;
	lf->lfClipPrecision = CLIP_DEFAULT_PRECIS;
	lf->lfQuality = DEFAULT_QUALITY;
	lf->lfPitchAndFamily = FIXED_PITCH | FF_DONTCARE;

	// tF[Xl[͎w肳ꂽ̂g
	_tcscpy(lf->lfFaceName, lpszFaceName);
}

//---------------------------------------------------------------------------
//
//	N[Abv
//
//---------------------------------------------------------------------------
void FASTCALL CGROM::Cleanup()
{
	int nSize;

	ASSERT(this);

	// DC݂ꍇɌ
	if (m_hDC) {
		// rbg}bvEtHg߂
		ASSERT(m_hBitmapBk);
		::SelectObject(m_hDC, m_hBitmapBk);
		ASSERT(m_hFontBk);
		::SelectObject(m_hDC, m_hFontBk);

		// rbg}bv폜
		ASSERT(m_hDIBitmap);
		::DeleteObject(m_hDIBitmap);
		m_hDIBitmap = NULL;
		m_pBits = NULL;

		// tHg폜
		for (nSize=0; nSize<SizeMax; nSize++) {
			// SVbN
			ASSERT(m_hGothic[nSize]);
			::DeleteObject(m_hGothic[nSize]);
			m_hGothic[nSize] = NULL;

			// 
			ASSERT(m_hMincho[nSize]);
			::DeleteObject(m_hMincho[nSize]);
			m_hMincho[nSize] = NULL;
		}

		// DC
		::ReleaseDC(AfxGetApp()->m_pMainWnd->m_hWnd, m_hDC);
		m_hDC = NULL;
	}

	// obt@
	if (m_pBuf) {
		delete[] m_pBuf;
		m_pBuf = NULL;
	}
	if (m_pTemp) {
		delete[] m_pTemp;
		m_pTemp = NULL;
	}
}

//---------------------------------------------------------------------------
//
//	tHgCXg[Ă邩
//
//---------------------------------------------------------------------------
BOOL FASTCALL CGROM::IsInstalled()
{
	HDC hDC;
	LOGFONT lf;

	ASSERT(this);

	// 
	m_szGothicName[0] = _T('\0');
	m_szMinchoName[0] = _T('\0');

	// DC擾
	ASSERT(AfxGetApp()->m_pMainWnd);
	ASSERT(AfxGetApp()->m_pMainWnd->m_hWnd);
	hDC = ::GetDC(AfxGetApp()->m_pMainWnd->m_hWnd);
	ASSERT(hDC);

	// lfCharset, FaceName, PitchAndFamilŷݐݒ
	memset(&lf, 0, sizeof(lf));
	lf.lfCharSet = SHIFTJIS_CHARSET;
	lf.lfFaceName[0] = _T('\0');
	lf.lfPitchAndFamily = 0;

	// tHg
	::EnumFontFamiliesEx(hDC, &lf, (FONTENUMPROC)EnumFontFamExCb, (LPARAM)this, 0);

	// DC
	::ReleaseDC(AfxGetApp()->m_pMainWnd->m_hWnd, hDC);

	// ǂ炩̃tHgȂAG[
	if ((m_szGothicName[0] == _T('\0')) || (m_szMinchoName[0] == _T('\0'))) {
		return FALSE;
	}

	// tHg
	return TRUE;
}

//---------------------------------------------------------------------------
//
//	EnumFontFamiliesExR[obN
//
//---------------------------------------------------------------------------
int CALLBACK CGROM::EnumFontFamExCb(ENUMLOGFONTEX *lpelfe, NEWTEXTMETRICEX* /*lpntme*/,
		DWORD FontType, LPARAM lParam)
{
	CGROM *pCGROM;
	LOGFONT *plf;
	UINT nType;

	// LXg
	pCGROM = (CGROM*)lParam;

	// KTrueTypetHgłȂ΂ȂȂ
	if (FontType != TRUETYPE_FONTTYPE) {
		return TRUE;
	}

	// lpelfe̐擪́AKLOGFONTɂȂ(\̂̒`ɂ)
	plf = (LOGFONT*)lpelfe;

	// Œsb`tHĝ݋
	if ((plf->lfPitchAndFamily & 0x03) != FIXED_PITCH) {
		return TRUE;
	}

	// 擪'@'ȂActHgȂ̂ŁAƂ
	if (plf->lfFaceName[0] == _T('@')) {
		return TRUE;
	}

	// ʂNA
	nType = 0;

	// tHgl[r邱ƂŁA肷
	// Win98SE(JP),Win2000(US),WinXP(JP)ŃeXgʁÃASYƂ
	if (_tcscmp(plf->lfFaceName, _T("lr SVbN")) == 0) {
		nType = 1;
	}
	if (_tcscmp(plf->lfFaceName, _T("MS Gothic")) == 0) {
		nType = 1;
	}
	if (_tcscmp(plf->lfFaceName, _T("lr ")) == 0) {
		nType = 2;
	}
	if (_tcscmp(plf->lfFaceName, _T("MS Mincho")) == 0) {
		nType = 2;
	}

	// Rs[
	switch (nType) {
		// SVbN
		case 1:
			// ܂o^ĂȂ΁ARs[(ŏɌ̂D)
			if (pCGROM->m_szGothicName[0] == _T('\0')) {
				_tcscpy(pCGROM->m_szGothicName, plf->lfFaceName);
			}
			break;

		// 
		case 2:
			// ܂o^ĂȂ΁ARs[(ŏɌ̂D)
			if (pCGROM->m_szMinchoName[0] == _T('\0')) {
				_tcscpy(pCGROM->m_szMinchoName, plf->lfFaceName);
			}
			break;

		// ̑
		default:
			break;
	}

	// 
	return TRUE;
}

//---------------------------------------------------------------------------
//
//	쐬
//
//---------------------------------------------------------------------------
BOOL FASTCALL CGROM::Create(Filepath& path, DWORD dwVer)
{
	Fileio fio;

	ASSERT(this);
	ASSERT(m_hDC);
	ASSERT(m_pBuf);

	// ׂăNA
	memset(m_pBuf, 0, 0xc0000);

	// 쐬
	Create8x8();
	Create8x16();
	Create12x12();
	Create12x24();
	Create16x16();
	Create24x24();
	CreateVer(dwVer);

	// Z[u
	if (fio.Open(path, Fileio::WriteOnly)) {
		// 
		fio.Write(m_pBuf, 0xc0000);
		fio.Close();

		// 
		return TRUE;
	}

	// Z[ułȂ
	return FALSE;
}

//---------------------------------------------------------------------------
//
//	쐬(8x8)
//
//---------------------------------------------------------------------------
void FASTCALL CGROM::Create8x8()
{
	ASSERT(this);
	ASSERT(m_pBuf);

	// f[^Rs[邾
	memcpy(&m_pBuf[0x3a008], Font8x8, 0x7e8);
}

//---------------------------------------------------------------------------
//
//	쐬(8x16)
//
//---------------------------------------------------------------------------
void FASTCALL CGROM::Create8x16()
{
	ASSERT(this);
	ASSERT(m_pBuf);
	ASSERT(m_pTemp);

	// SVbN(8x16)쐬
	GetFontGen(TRUE, 0, (int)Size8x16);

	// Rs[
	memcpy(&m_pBuf[0x3aa10], &m_pTemp[0x010], 0x5e0);
	memcpy(&m_pBuf[0x3b210], &m_pTemp[0x610], 0x3f0);

	// f[^쐬
	memcpy(&m_pBuf[0x3a810], &Font8x16[0x000], 0x1f0);
	memcpy(&m_pBuf[0x3b000], &Font8x16[0x0f8], 0x030);
	memcpy(&m_pBuf[0x3b060], &Font8x16[0x110], 0x0a0);
	memcpy(&m_pBuf[0x3b110], &Font8x16[0x160], 0x0f0);
	memcpy(&m_pBuf[0x3b600], &Font8x16[0x1d8], 0x1e0);
}

//---------------------------------------------------------------------------
//
//	쐬(12x12)
//
//---------------------------------------------------------------------------
void FASTCALL CGROM::Create12x12()
{
	int nLine;

	ASSERT(this);
	ASSERT(m_pBuf);
	ASSERT(m_pTemp);

	// p쐬邽߁ASp
	for (nLine=0; nLine<14; nLine++) {
		// 
		GetFontStr(FALSE, TRUE, HankakuTable[nLine], (int)Size6x12);
		memcpy(&m_pBuf[0x3b800 + (nLine + 2) * 0x180], m_pTemp, 0x180);
	}

	// f[^쐬
	memcpy(&m_pBuf[0x3b818], &Font12x12[0x000], 0x2e8);
	memcpy(&m_pBuf[0x3c400], &Font12x12[0x174], 0x048);
}

//---------------------------------------------------------------------------
//
//	쐬(12x24)
//
//---------------------------------------------------------------------------
void FASTCALL CGROM::Create12x24()
{
	int nBlock;

	ASSERT(this);
	ASSERT(m_pBuf);
	ASSERT(m_pTemp);

	// (12x24)쐬
	GetFontGen(FALSE, 0, (int)Size12x24);

	// Rs[
	memcpy(&m_pBuf[0x3d630], &m_pTemp[0x0030], 0x11a0);
	memcpy(&m_pBuf[0x3ee30], &m_pTemp[0x1230], 0x0bd0);

	// Ђ炪
	for (nBlock=0; nBlock<2; nBlock++) {
		// (6x24)
		GetFontStr(FALSE, TRUE, HankakuTable[nBlock + 6], (int)Size6x24);
		memcpy(&m_pBuf[0x3d000 + ((nBlock + 8) * 0x300)], m_pTemp, 0x300);
		GetFontStr(FALSE, TRUE, HankakuTable[nBlock + 12], (int)Size6x24);
		memcpy(&m_pBuf[0x3d000 + ((nBlock + 14) * 0x300)], m_pTemp, 0x300);
	}

	// f[^쐬
	memcpy(&m_pBuf[0x3d030], &Font12x24[0x000], 0x5d0);
	memcpy(&m_pBuf[0x3e800], &Font12x24[0x2e8], 0x090);
}

//---------------------------------------------------------------------------
//
//	쐬(16x16)
//
//---------------------------------------------------------------------------
void FASTCALL CGROM::Create16x16()
{
	int nHigh;

	ASSERT(this);
	ASSERT(m_pBuf);
	ASSERT(m_pTemp);

	// 0x21xx`0x28xx
	for (nHigh=0; nHigh<7; nHigh++) {
		// WinX68k͖gpĂ邪AXM6̓SVbN֕ύX
		GetFontGen(TRUE, nHigh + 0x21, (int)Size8x16);
		memcpy(&m_pBuf[nHigh * 0xbc0], &m_pTemp[32], 0xbc0);
	}

	// 0x30xx`0x74xx
	for (nHigh=0; nHigh<0x45; nHigh++) {
		// SVbN
		GetFontGen(TRUE, nHigh + 0x30, (int)Size8x16);
		memcpy(&m_pBuf[(nHigh + 8) * 0xbc0], &m_pTemp[32], 0xbc0);
	}

	// f[^쐬
	memcpy(&m_pBuf[0x5240], Font16x16, 0x400);
}

//---------------------------------------------------------------------------
//
//	쐬(24x24)
//
//---------------------------------------------------------------------------
void FASTCALL CGROM::Create24x24()
{
	int nHigh;

	ASSERT(this);
	ASSERT(m_pBuf);
	ASSERT(m_pTemp);

	// 0x21xx`0x28xx
	for (nHigh=0; nHigh<7; nHigh++) {
		// 
		GetFontGen(FALSE, nHigh + 0x21, (int)Size12x24);
		memcpy(&m_pBuf[0x40000 + nHigh * 0x1a70], &m_pTemp[72], 0x1a70);
	}

	// 0x30xx`0x74xx
	for (nHigh=0; nHigh<0x45; nHigh++) {
		// 
		GetFontGen(FALSE, nHigh + 0x30, (int)Size12x24);
		memcpy(&m_pBuf[0x40000 + (nHigh + 8) * 0x1a70], &m_pTemp[72], 0x1a70);
	}

	// f[^쐬
	memcpy(&m_pBuf[0x4b910], Font24x24, 0x900);
}

//---------------------------------------------------------------------------
//
//	쐬(o[W)
//
//---------------------------------------------------------------------------
void FASTCALL CGROM::CreateVer(DWORD dwVer)
{
	char version[8];

	// wb_"XM6 "
	strcpy((char*)&m_pBuf[0xbfff8], "XM6 ");

	// o[W
	sprintf(version, "%01X.%02X", (BYTE)(dwVer >> 8), (BYTE)dwVer);
	memcpy(&m_pBuf[0xbfffc], version, 4);
}

//---------------------------------------------------------------------------
//
//	w肵񂩂AtHg擾
//
//---------------------------------------------------------------------------
void FASTCALL CGROM::GetFontStr(BOOL bGothic, BOOL bZenkaku, LPCTSTR lpszText, int nSize)
{
	RECT rect;
	TCHAR szText[3];
	BYTE *pCurrent;
	int nAdd;

	ASSERT(this);
	ASSERT(m_hDC);
	ASSERT(m_pTemp);
	ASSERT(lpszText);
	ASSERT(nSize >= 0);
	ASSERT(nSize < SizeMax);

	// tHgI
	if (bGothic) {
		ASSERT(m_hGothic[nSize]);
		::SelectObject(m_hDC, m_hGothic[nSize]);
	}
	else {
		ASSERT(m_hMincho[nSize]);
		::SelectObject(m_hDC, m_hMincho[nSize]);
	}

	// `ݒ
	rect.left = 0;
	rect.top = 0;
	rect.right = 32;
	rect.bottom = 32;

	// Jg|C^
	pCurrent = m_pTemp;

	// 1Pʂŏ
	while (*lpszText != _T('\0')) {
#if defined(UNICODE)
		szText[0] = *lpszText;
		szText[1] = _T('\0');
		lpszText++;
#else
		if (bZenkaku) {
			szText[0] = lpszText[0];
			szText[1] = lpszText[1];
			szText[2] = _T('\0');
			lpszText += 2;
		}
		else {
			szText[0] = *lpszText;
			szText[1] = _T('\0');
			lpszText++;
		}
#endif	// UNICODE

		// œhԂ
		::FillRect(m_hDC, &rect, (HBRUSH)GetStockObject(BLACK_BRUSH));

		// `
#if defined(UNICODE)
		VERIFY(::TextOut(m_hDC, 0, 0, szText, 1));
#else
		if(bZenkaku) {
			VERIFY(::TextOut(m_hDC, 0, 0, szText, 2));
		}
		else {
			VERIFY(::TextOut(m_hDC, 0, 0, szText, 1));
		}
#endif	// UNICODE

		// m_pBitsRs[
		nAdd = CopyFromBits(pCurrent, bZenkaku, nSize);
		pCurrent += nAdd;
	}
}

//---------------------------------------------------------------------------
//
//	m_pBitstHgf[^Rs[
//
//---------------------------------------------------------------------------
int FASTCALL CGROM::CopyFromBits(BYTE *pDest, BOOL bZenkaku, int nSize)
{
	int y;
	BYTE *pSrc;

	ASSERT(this);
	ASSERT(pDest);
	ASSERT(nSize >= 0);
	ASSERT(nSize < SizeMax);

	// \[XZbg
	pSrc = m_pBits;
	ASSERT(pSrc);

	// TCY
	switch ((FontSize)nSize) {
		// 6x12
		case Size6x12:
			// Sp̂
			ASSERT(bZenkaku);

			// y[v
			for (y=0; y<12; y++) {
				// pSrĉ4bit͎gȂ
				*pDest++ = pSrc[0];
				*pDest++ = (BYTE)(pSrc[1] & 0xf0);

				// y
				pSrc += 4;
			}

			// Sp̂
			return 24;

		// 8x16
		case Size8x16:
			// y[v
			for (y=0; y<16; y++) {
				// pȂ1oCgASpȂ2oCg
				if (bZenkaku) {
					*pDest++ = pSrc[0];
					*pDest++ = pSrc[1];
				}
				else {
					*pDest++ = pSrc[0];
				}

				// y
				pSrc += 4;
			}

			// pȂ16oCgASpȂ32oCg
			if (bZenkaku) {
				return 32;
			}
			return 16;

		// 6x24
		case Size6x24:
			// Sp̂
			ASSERT(bZenkaku);

			// y[v
			for (y=0; y<24; y++) {
				// SpȂ̂2oCg
				*pDest++ = pSrc[0];
				*pDest++ = pSrc[1];

				// y
				pSrc += 4;
			}

			// Sp̂
			return 48;

		// 12x24
		case Size12x24:
			// y[v
			for (y=0; y<24; y++) {
				// pȂ2oCgASpȂ3oCg
				if (bZenkaku) {
					*pDest++ = pSrc[0];
					*pDest++ = pSrc[1];
					*pDest++ = pSrc[2];
				}
				else {
					*pDest++ = pSrc[0];
					*pDest++ = (BYTE)(pSrc[1] & 0xf0);
				}

				// y
				pSrc += 4;
			}

			// pȂ48oCgASpȂ72oCg
			if (bZenkaku) {
				return 72;
			}
			return 48;

		default:
			ASSERT(FALSE);
	}

	return 0;
}

//---------------------------------------------------------------------------
//
//	쐬ŁAtHg擾
//
//---------------------------------------------------------------------------
void FASTCALL CGROM::GetFontGen(BOOL bGothic, DWORD dwBase, int nSize)
{
	int nChr;
	TCHAR szText[0x100];
	const int *pTable;
	WORD *pWord;
#if defined(UNICODE)
	WORD szMBCS[0x100];
#endif	// UNICODE

	ASSERT(nSize >= 0);
	ASSERT(nSize < SizeMax);

	// dwBase=0ŔpAȊÓASpӖ
	if (dwBase == 0) {
		// dwBase0̏ꍇAp
		for (nChr=0; nChr<0x5f; nChr++) {
			szText[nChr] = (TCHAR)(nChr + 0x20);
		}
		szText[0x5f] = _T(' ');
		szText[0x60] = _T(' ');
		for (nChr=0x01; nChr<0x40; nChr++) {
			szText[nChr + 0x60] = (TCHAR)(nChr + 0xa0);
		}
		szText[0xa0] = _T('\0');

		// tHg쐬(p)
		GetFontStr(bGothic, FALSE, szText, nSize);
		return;
	}

	// Sp

#if defined(UNICODE)
	// ܂AXy[X(Sp)Zbg
	pWord = (WORD*)szMBCS;
	pWord[0] = 0x4081;
#else
	// ܂AXy[X(Sp)Zbg
	pWord = (WORD*)szText;
	pWord[0] = 0x4081;
#endif	// UNICODE

	// JISSHIFT-JISϊsŁAZbg
	for (nChr=1; nChr<0x5f; nChr++) {
		pWord[nChr] = Jis2ShiftJis((WORD)((dwBase << 8) + nChr + 0x20));
	}

	// Gh}[Nݒ
	szText[nChr * 2] = _T('\0');

	// O
	switch (dwBase) {
		// 0x22`0x27
		case 0x22:
		case 0x23:
		case 0x24:
		case 0x25:
		case 0x26:
		case 0x27:

			// |C^
			pTable = &ExceptTable[0];

			// XLbv
			while (dwBase > 0x22) {
				// ꂼ̃e[u̖0ŏÎŁAT[`ēǂݔ΂
				while (*pTable++) {
					;
				}
				dwBase--;
			}

			// e[uփ|Cgł
			while (*pTable) {
				// [擾
				nChr = *pTable++;

				// [܂Ń[v
				while (nChr < *pTable) {
					pWord[nChr++] = 0x4081;
				}

				// 
				pTable++;
			}
			break;

		// ʂ0x4f
		case 0x4f:
			for (nChr=0x34; nChr<0x5f; nChr++) {
				pWord[nChr] = 0x4081;
			}
			break;

		// ʂ0x74
		case 0x74:
			for (nChr=0x05; nChr<0x5f; nChr++) {
				pWord[nChr] = 0x4081;
			}
			break;
	}

#if defined(UNICODE)
	// SHIFT-JIS(CP932)AUTF-8ցAXɕϊ
	::MultiByteToWideChar(932, MB_PRECOMPOSED, (LPCSTR)szMBCS, -1, szText, 0x100);
#endif	// UNICODE

	// tHg쐬(Sp)
	GetFontStr(bGothic, TRUE, szText, nSize);
}

//---------------------------------------------------------------------------
//
//	JISSHIFT-JISϊ
//
//---------------------------------------------------------------------------
WORD FASTCALL CGROM::Jis2ShiftJis(WORD wJis)
{
	BYTE high;
	BYTE low;

	// ʁEʂɕ
	high = (BYTE)(wJis >> 8);
	low = (BYTE)wJis;

	// {IɁAAZũASŶ܂܈ڐA
	high += 0x21;
	if (high & 1) {
		low += 0x5e;
	}
	high >>= 1;
	high ^= 0x20;
	high |= 0x80;

	if (low >= 0x60) {
		low++;
	}
	low += 0x1f;

	// gGfBÂ߁At]č
	return (WORD)((low << 8) | high);
}

//---------------------------------------------------------------------------
//
//	tHgf[^(8x8)
//
//---------------------------------------------------------------------------
const BYTE CGROM::Font8x8[0x7e8] = {
	0x60,0x80,0x60,0x12,0xF2,0x1E,0x12,0x12,
	0x60,0x80,0x60,0x12,0xF2,0x0C,0x12,0x12,
	0xF0,0x80,0xE0,0x92,0xF2,0x0C,0x12,0x12,
	0xF0,0x80,0xE0,0x8E,0xF4,0x04,0x04,0x04,
	0xF0,0x80,0xE0,0x8C,0xF2,0x12,0x16,0x0E,
	0x60,0x90,0x90,0xF2,0x94,0x18,0x14,0x12,
	0xE0,0x90,0xE0,0x90,0xF0,0x10,0x10,0x1E,
	0xE0,0x90,0xE0,0x9C,0xF0,0x0C,0x02,0x1C,
	0x90,0x90,0xF0,0x9E,0x94,0x04,0x04,0x04,
	0x80,0x80,0x80,0x9E,0xF0,0x1C,0x10,0x10,
	0x90,0x90,0x90,0x9E,0x64,0x04,0x04,0x04,
	0xF0,0x80,0xE0,0x9E,0x90,0x1C,0x10,0x10,
	0x70,0x80,0x80,0x9C,0x72,0x1E,0x14,0x12,
	0x60,0x80,0x60,0x1C,0xF2,0x12,0x12,0x0C,
	0x60,0x80,0x60,0x1E,0xE4,0x04,0x04,0x0E,
	0xE0,0x90,0x90,0x9E,0xF0,0x1C,0x10,0x1E,
	0xE0,0x90,0x90,0x92,0xE6,0x02,0x02,0x02,
	0xE0,0x90,0x90,0x94,0xEA,0x02,0x04,0x0E,
	0xE0,0x90,0x90,0x9E,0xE4,0x02,0x12,0x0C,
	0xE0,0x90,0x90,0x94,0xE4,0x14,0x1E,0x04,
	0x90,0xD0,0xB0,0x92,0x94,0x18,0x14,0x12,
	0x60,0x80,0x60,0x12,0xFA,0x16,0x12,0x12,
	0xF0,0x80,0xE0,0x9C,0xF2,0x1C,0x12,0x1C,
	0x70,0x80,0x80,0x92,0x7A,0x16,0x12,0x12,
	0xF0,0x80,0xE0,0x92,0xFE,0x12,0x12,0x12,
	0xF0,0x80,0xE0,0x8E,0xF0,0x10,0x10,0x0E,
	0x70,0x40,0x70,0x40,0x7E,0x10,0x10,0x0E,
	0x00,0x08,0x04,0x7E,0x04,0x08,0x00,0x00,
	0x00,0x10,0x20,0x7E,0x20,0x10,0x00,0x00,
	0x00,0x10,0x38,0x54,0x10,0x10,0x10,0x00,
	0x00,0x10,0x10,0x10,0x54,0x38,0x10,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x08,0x08,0x08,0x08,0x08,0x00,0x08,0x00,
	0x14,0x14,0x00,0x00,0x00,0x00,0x00,0x00,
	0x24,0x24,0x7E,0x24,0x24,0x7E,0x24,0x00,
	0x08,0x1C,0x28,0x1C,0x0A,0x1C,0x08,0x00,
	0x00,0x62,0x64,0x08,0x10,0x26,0x46,0x00,
	0x30,0x48,0x48,0x30,0x4A,0x44,0x3A,0x00,
	0x18,0x08,0x10,0x00,0x00,0x00,0x00,0x00,
	0x04,0x08,0x10,0x10,0x10,0x08,0x04,0x00,
	0x20,0x10,0x08,0x08,0x08,0x10,0x20,0x00,
	0x00,0x14,0x08,0x3E,0x08,0x14,0x00,0x00,
	0x00,0x08,0x08,0x3E,0x08,0x08,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x18,0x08,0x10,
	0x00,0x00,0x00,0x3E,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,
	0x00,0x02,0x04,0x08,0x10,0x20,0x40,0x00,
	0x3C,0x42,0x46,0x5A,0x62,0x42,0x3C,0x00,
	0x08,0x18,0x08,0x08,0x08,0x08,0x1C,0x00,
	0x3C,0x42,0x02,0x0C,0x30,0x40,0x7E,0x00,
	0x7E,0x04,0x08,0x1C,0x02,0x42,0x3C,0x00,
	0x0C,0x14,0x24,0x44,0x7E,0x04,0x04,0x00,
	0x7E,0x40,0x7C,0x02,0x02,0x42,0x3C,0x00,
	0x20,0x20,0x20,0x3C,0x42,0x42,0x3C,0x00,
	0x7E,0x42,0x04,0x04,0x08,0x08,0x10,0x00,
	0x3C,0x42,0x42,0x3C,0x42,0x42,0x3C,0x00,
	0x3C,0x42,0x42,0x3C,0x04,0x04,0x04,0x00,
	0x00,0x00,0x18,0x18,0x00,0x18,0x18,0x00,
	0x00,0x00,0x18,0x18,0x00,0x18,0x08,0x10,
	0x04,0x08,0x10,0x20,0x10,0x08,0x04,0x00,
	0x00,0x00,0x7E,0x00,0x7E,0x00,0x00,0x00,
	0x20,0x10,0x08,0x04,0x08,0x10,0x20,0x00,
	0x3C,0x66,0x06,0x0C,0x10,0x00,0x10,0x00,
	0x1C,0x22,0x4A,0x56,0x4C,0x20,0x1E,0x00,
	0x18,0x24,0x24,0x42,0x7E,0x42,0x42,0x00,
	0x7C,0x42,0x42,0x7C,0x42,0x42,0x7C,0x00,
	0x1C,0x22,0x40,0x40,0x40,0x22,0x1C,0x00,
	0x78,0x44,0x42,0x42,0x42,0x44,0x78,0x00,
	0x7E,0x40,0x40,0x78,0x40,0x40,0x7E,0x00,
	0x7E,0x40,0x40,0x78,0x40,0x40,0x40,0x00,
	0x1C,0x22,0x40,0x4E,0x42,0x22,0x1E,0x00,
	0x42,0x42,0x42,0x7E,0x42,0x42,0x42,0x00,
	0x1C,0x08,0x08,0x08,0x08,0x08,0x1C,0x00,
	0x0E,0x04,0x04,0x04,0x04,0x44,0x38,0x00,
	0x42,0x44,0x48,0x70,0x48,0x44,0x42,0x00,
	0x40,0x40,0x40,0x40,0x40,0x40,0x7E,0x00,
	0x42,0x66,0x5A,0x5A,0x42,0x42,0x42,0x00,
	0x42,0x62,0x52,0x4A,0x46,0x42,0x42,0x00,
	0x3C,0x42,0x42,0x42,0x42,0x42,0x3C,0x00,
	0x7C,0x42,0x42,0x7C,0x40,0x40,0x40,0x00,
	0x3C,0x42,0x42,0x42,0x4A,0x44,0x3A,0x00,
	0x7C,0x42,0x42,0x7C,0x44,0x42,0x42,0x00,
	0x3C,0x42,0x20,0x18,0x04,0x42,0x3C,0x00,
	0x3E,0x08,0x08,0x08,0x08,0x08,0x08,0x00,
	0x42,0x42,0x42,0x42,0x42,0x42,0x3C,0x00,
	0x42,0x42,0x42,0x24,0x24,0x18,0x18,0x00,
	0x42,0x42,0x42,0x5A,0x5A,0x66,0x42,0x00,
	0x42,0x42,0x24,0x18,0x24,0x42,0x42,0x00,
	0x22,0x22,0x22,0x1C,0x08,0x08,0x08,0x00,
	0x7E,0x02,0x04,0x18,0x20,0x40,0x7E,0x00,
	0x1C,0x10,0x10,0x10,0x10,0x10,0x1C,0x00,
	0x22,0x22,0x14,0x3E,0x08,0x3E,0x08,0x00,
	0x38,0x08,0x08,0x08,0x08,0x08,0x38,0x00,
	0x08,0x14,0x22,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,
	0x06,0x04,0x02,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x3C,0x02,0x3E,0x42,0x3E,0x00,
	0x40,0x40,0x5C,0x62,0x42,0x62,0x5C,0x00,
	0x00,0x00,0x3C,0x42,0x40,0x42,0x3C,0x00,
	0x02,0x02,0x3A,0x46,0x42,0x46,0x3A,0x00,
	0x00,0x00,0x3C,0x42,0x7E,0x40,0x3C,0x00,
	0x0E,0x10,0x10,0x7C,0x10,0x10,0x10,0x00,
	0x00,0x00,0x3A,0x46,0x46,0x3A,0x02,0x3C,
	0x40,0x40,0x5C,0x62,0x42,0x42,0x42,0x00,
	0x08,0x00,0x18,0x08,0x08,0x08,0x1C,0x00,
	0x04,0x00,0x0C,0x04,0x04,0x04,0x24,0x18,
	0x40,0x40,0x44,0x48,0x50,0x68,0x44,0x00,
	0x18,0x08,0x08,0x08,0x08,0x08,0x1C,0x00,
	0x00,0x00,0x76,0x49,0x49,0x49,0x49,0x00,
	0x00,0x00,0x5C,0x62,0x42,0x42,0x42,0x00,
	0x00,0x00,0x3C,0x42,0x42,0x42,0x3C,0x00,
	0x00,0x00,0x5C,0x62,0x62,0x5C,0x40,0x40,
	0x00,0x00,0x3A,0x46,0x46,0x3A,0x02,0x02,
	0x00,0x00,0x5C,0x62,0x40,0x40,0x40,0x00,
	0x00,0x00,0x3C,0x40,0x3C,0x02,0x7C,0x00,
	0x10,0x10,0x7C,0x10,0x10,0x10,0x0C,0x00,
	0x00,0x00,0x42,0x42,0x42,0x46,0x3A,0x00,
	0x00,0x00,0x42,0x42,0x42,0x24,0x18,0x00,
	0x00,0x00,0x41,0x49,0x49,0x49,0x36,0x00,
	0x00,0x00,0x42,0x24,0x18,0x24,0x42,0x00,
	0x00,0x00,0x42,0x42,0x42,0x3E,0x02,0x3C,
	0x00,0x00,0x7E,0x04,0x18,0x20,0x7E,0x00,
	0x0C,0x10,0x10,0x20,0x10,0x10,0x0C,0x00,
	0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x00,
	0x30,0x08,0x08,0x04,0x08,0x08,0x30,0x00,
	0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x00,
	0x60,0xDA,0x0C,0x00,0x00,0x00,0x00,0x00,
	0x10,0x10,0x10,0x00,0x10,0x10,0x10,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x10,0x7C,0x10,0x1C,0x28,0x20,0x1E,0x00,
	0x00,0x00,0x10,0x38,0x14,0x7E,0x34,0x00,
	0x00,0x00,0x00,0x44,0x42,0x52,0x20,0x00,
	0x00,0x00,0x18,0x00,0x3C,0x04,0x18,0x00,
	0x00,0x00,0x18,0x00,0x3C,0x08,0x34,0x00,
	0x00,0x00,0x12,0x7A,0x10,0x7C,0x74,0x00,
	0x00,0x00,0x04,0x28,0x7C,0x22,0x24,0x00,
	0x00,0x00,0x48,0x7C,0x4A,0x5C,0x08,0x00,
	0x00,0x00,0x08,0x0C,0x08,0x3C,0x3A,0x00,
	0x00,0x00,0x00,0x3C,0x02,0x02,0x0C,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x10,0x3C,0x10,0x3E,0x55,0x59,0x32,0x00,
	0x00,0x20,0x44,0x42,0x42,0x50,0x20,0x00,
	0x18,0x00,0x3C,0x02,0x02,0x04,0x18,0x00,
	0x18,0x00,0x3C,0x08,0x10,0x28,0x46,0x00,
	0x10,0x3A,0x12,0x3C,0x52,0x52,0x24,0x00,
	0x24,0x24,0x7A,0x26,0x24,0x24,0x4C,0x00,
	0x10,0x3C,0x10,0x7E,0x08,0x40,0x3C,0x00,
	0x0C,0x10,0x20,0x20,0x10,0x08,0x0C,0x00,
	0x04,0x5E,0x44,0x44,0x44,0x24,0x08,0x00,
	0x00,0x38,0x04,0x00,0x00,0x40,0x3C,0x00,
	0x10,0x3C,0x10,0x08,0x00,0x40,0x3C,0x00,
	0x20,0x20,0x20,0x20,0x20,0x24,0x18,0x00,
	0x04,0x7E,0x0C,0x14,0x1C,0x04,0x18,0x00,
	0x04,0x24,0x7E,0x24,0x2C,0x20,0x1C,0x00,
	0x48,0x10,0x26,0x78,0x20,0x20,0x1C,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x38,0x28,0x38,0x00,
	0x1C,0x10,0x10,0x10,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x08,0x08,0x08,0x38,0x00,
	0x00,0x00,0x00,0x00,0x20,0x10,0x08,0x00,
	0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,
	0x00,0x3E,0x02,0x3E,0x02,0x04,0x18,0x00,
	0x00,0x00,0x3E,0x02,0x0C,0x08,0x10,0x00,
	0x00,0x00,0x04,0x08,0x18,0x28,0x08,0x00,
	0x00,0x00,0x08,0x3E,0x22,0x02,0x0C,0x00,
	0x00,0x00,0x00,0x3E,0x08,0x08,0x3E,0x00,
	0x00,0x00,0x04,0x3E,0x0C,0x14,0x24,0x00,
	0x00,0x00,0x10,0x3E,0x12,0x14,0x10,0x00,
	0x00,0x00,0x00,0x1C,0x04,0x04,0x3E,0x00,
	0x00,0x00,0x3C,0x04,0x3C,0x04,0x3C,0x00,
	0x00,0x00,0x00,0x2A,0x2A,0x02,0x0C,0x00,
	0x00,0x00,0x00,0x3E,0x00,0x00,0x00,0x00,
	0x00,0x7E,0x02,0x14,0x18,0x10,0x20,0x00,
	0x02,0x04,0x08,0x18,0x28,0x08,0x08,0x00,
	0x00,0x08,0x7E,0x42,0x02,0x04,0x18,0x00,
	0x00,0x3E,0x08,0x08,0x08,0x08,0x3E,0x00,
	0x00,0x08,0x7E,0x08,0x18,0x28,0x48,0x00,
	0x00,0x10,0x7E,0x12,0x12,0x22,0x24,0x00,
	0x00,0x08,0x3E,0x08,0x3E,0x08,0x08,0x00,
	0x00,0x1E,0x22,0x42,0x04,0x08,0x30,0x00,
	0x00,0x20,0x3E,0x48,0x08,0x08,0x10,0x00,
	0x00,0x7E,0x02,0x02,0x02,0x02,0x7E,0x00,
	0x00,0x24,0x7E,0x24,0x04,0x04,0x18,0x00,
	0x00,0x70,0x00,0x72,0x02,0x04,0x78,0x00,
	0x00,0x7E,0x02,0x04,0x08,0x14,0x62,0x00,
	0x00,0x20,0x7E,0x22,0x24,0x20,0x1E,0x00,
	0x00,0x22,0x22,0x12,0x02,0x04,0x18,0x00,
	0x00,0x1E,0x12,0x2A,0x06,0x04,0x18,0x00,
	0x00,0x3C,0x08,0x7E,0x08,0x08,0x10,0x00,
	0x00,0x52,0x52,0x52,0x02,0x04,0x18,0x00,
	0x00,0x3C,0x00,0x7E,0x08,0x08,0x10,0x00,
	0x00,0x10,0x10,0x18,0x14,0x10,0x10,0x00,
	0x00,0x08,0x7E,0x08,0x08,0x10,0x20,0x00,
	0x00,0x3C,0x00,0x00,0x00,0x00,0x7E,0x00,
	0x00,0x3E,0x02,0x14,0x08,0x14,0x20,0x00,
	0x00,0x08,0x3E,0x04,0x1C,0x2A,0x08,0x00,
	0x00,0x02,0x02,0x04,0x04,0x08,0x30,0x00,
	0x00,0x08,0x24,0x22,0x42,0x42,0x42,0x00,
	0x00,0x40,0x7E,0x40,0x40,0x40,0x3E,0x00,
	0x00,0x7E,0x02,0x02,0x04,0x08,0x30,0x00,
	0x00,0x00,0x10,0x28,0x44,0x02,0x00,0x00,
	0x00,0x08,0x3E,0x08,0x2A,0x2A,0x08,0x00,
	0x00,0x7E,0x02,0x04,0x28,0x10,0x08,0x00,
	0x00,0x3C,0x00,0x3C,0x00,0x7C,0x02,0x00,
	0x00,0x10,0x20,0x40,0x44,0x7C,0x02,0x00,
	0x00,0x02,0x02,0x14,0x08,0x14,0x20,0x00,
	0x00,0x7E,0x10,0x7E,0x10,0x10,0x1E,0x00,
	0x20,0x20,0x7E,0x22,0x24,0x20,0x20,0x00,
	0x00,0x38,0x08,0x08,0x08,0x08,0x7E,0x00,
	0x00,0x7E,0x02,0x7E,0x02,0x02,0x7E,0x00,
	0x00,0x3C,0x00,0x7E,0x02,0x04,0x38,0x00,
	0x00,0x22,0x22,0x22,0x02,0x04,0x18,0x00,
	0x00,0x28,0x28,0x28,0x2A,0x2A,0x4C,0x00,
	0x00,0x20,0x20,0x22,0x24,0x28,0x30,0x00,
	0x00,0x3E,0x22,0x22,0x22,0x22,0x3E,0x00,
	0x00,0x7E,0x42,0x42,0x02,0x04,0x18,0x00,
	0x00,0x70,0x02,0x02,0x04,0x08,0x70,0x00,
	0x10,0x48,0x20,0x00,0x00,0x00,0x00,0x00,
	0x70,0x50,0x70,0x00,0x00,0x00,0x00,0x00,
	0x20,0x7E,0x20,0x2E,0x20,0x48,0x46,0x00,
	0x10,0x3C,0x10,0x3C,0x42,0x02,0x1C,0x00,
	0x00,0x7C,0x02,0x02,0x02,0x04,0x18,0x00,
	0x00,0x7E,0x04,0x08,0x10,0x10,0x0E,0x00,
	0x10,0x10,0x16,0x38,0x40,0x40,0x3E,0x00,
	0x10,0x7A,0x22,0x48,0x08,0x3C,0x3A,0x00,
	0x20,0x4E,0x40,0x40,0x40,0x50,0x4E,0x00,
	0x04,0x04,0x5C,0x2A,0x52,0x56,0x26,0x00,
	0x20,0x20,0x6C,0x32,0x22,0x66,0x66,0x00,
	0x00,0x1C,0x2A,0x4A,0x52,0x52,0x24,0x00,
	0x04,0x5E,0x44,0x44,0x44,0x5E,0x5C,0x00,
	0x00,0x76,0x22,0x44,0x44,0x44,0x38,0x00,
	0x00,0x10,0x20,0x10,0x4A,0x4A,0x10,0x00,
	0x00,0x10,0x28,0x44,0x06,0x02,0x00,0x00,
	0x00,0x44,0x5E,0x44,0x44,0x5E,0x5C,0x00,
	0x08,0x7E,0x08,0x3E,0x08,0x7E,0x7A,0x00,
	0x70,0x14,0x14,0x3E,0x54,0x54,0x20,0x00,
	0x20,0x72,0x22,0x60,0x60,0x22,0x1C,0x00,
	0x04,0x04,0x5C,0x2A,0x52,0x52,0x24,0x00,
	0x08,0x78,0x10,0x78,0x20,0x22,0x1C,0x00,
	0x28,0x28,0x7C,0x22,0x22,0x26,0x20,0x00,
	0x08,0x5C,0x6A,0x4A,0x4A,0x5C,0x08,0x00,
	0x08,0x0E,0x08,0x08,0x3C,0x4A,0x30,0x00,
	0x10,0x08,0x20,0x3C,0x02,0x02,0x0C,0x00,
	0x04,0x22,0x22,0x22,0x12,0x04,0x08,0x00,
	0x3C,0x08,0x10,0x3C,0x42,0x12,0x1E,0x00,
	0x20,0x24,0x6C,0x34,0x24,0x64,0x26,0x00,
	0x3C,0x08,0x10,0x3C,0x42,0x02,0x1C,0x00,
	0x20,0x20,0x6C,0x32,0x22,0x62,0x24,0x00,
	0x10,0x10,0x20,0x20,0x30,0x4A,0x4C,0x00
};

//---------------------------------------------------------------------------
//
//	tHgf[^(8x16)
//
//---------------------------------------------------------------------------
const WORD CGROM::Font8x16[0x2c8] = {
	0x4038,0x1830,0x7008,0x0020,0x1212,0x1E12,0x1216,0x0002,	// 1
	0x4038,0x1830,0x7008,0x0020,0x1A02,0x0C0C,0x121E,0x0002,	// 2
	0x6038,0x7040,0x7840,0x0020,0x1A02,0x0C0C,0x121E,0x0002,	// 3
	0x6038,0x7040,0x7840,0x0020,0x0C1E,0x0808,0x0808,0x0008,	// 4
	0x6038,0x7040,0x7840,0x0020,0x1A1C,0x1212,0x1E16,0x000A,	// 5
	0x6830,0x4848,0x4878,0x0048,0x1210,0x1C14,0x1418,0x0016,	// 6
	0x4870,0x5850,0x4848,0x0050,0x1018,0x1010,0x1E10,0x0004,	// 7
	0x4870,0x5850,0x4848,0x0050,0x100E,0x060C,0x1C02,0x0008,	// 8
	0x4848,0x7848,0x4858,0x0008,0x0C1E,0x0808,0x0808,0x0008,	// 9
	0x4060,0x4040,0x7840,0x0010,0x180E,0x1C10,0x1018,0x0010,	// a
	0x4848,0x4848,0x3050,0x0020,0x0C1E,0x0808,0x0808,0x0008,	// b
	0x6038,0x7040,0x4060,0x0040,0x180E,0x1C10,0x1018,0x0010,	// c
	0xD060,0x8080,0xF0D0,0x0020,0x121C,0x1412,0x1216,0x0010,	// d
	0x4038,0x1830,0x7008,0x0020,0x121C,0x1212,0x1C12,0x0008,	// e
	0x4038,0x1830,0x7008,0x0020,0x0C1E,0x080C,0x1E08,0x0008,	// f
	0x4870,0x4848,0x4848,0x0050,0x180E,0x1C10,0x1E10,0x0008,	//10
	0x4870,0x4848,0x4848,0x0050,0x0C08,0x040C,0x0404,0x0004,	//11
	0x4870,0x4848,0x4848,0x0050,0x120C,0x0406,0x1A08,0x001C,	//12
	0x4870,0x4848,0x4848,0x0050,0x1A0C,0x0C02,0x0602,0x000C,	//13
	0x4870,0x4848,0x4848,0x0050,0x1008,0x1414,0x040E,0x0008,	//14
	0x4858,0x6848,0x5868,0x0048,0x1210,0x1C14,0x1418,0x0016,	//15
	0x4038,0x1830,0x7008,0x0020,0x1216,0x1A12,0x161A,0x0012,	//16
	0x6038,0x7040,0x7840,0x0020,0x121C,0x1614,0x1212,0x0014,	//17
	0x6830,0x4040,0x7868,0x0010,0x1216,0x1A12,0x161A,0x0012,	//18
	0x6038,0x7040,0x7840,0x0020,0x3602,0x223E,0x2222,0x0022,	//19
	0x4038,0x1830,0x7008,0x0020,0x121C,0x1614,0x1212,0x0014,	//1a
	0x6038,0x7040,0x7840,0x0020,0x1A0C,0x1010,0x1E1A,0x0004,	//1b
	0x0000,0x0000,0x0808,0xFE04,0x0804,0x0008,0x0000,0x0000,	//1c
	0x0000,0x0000,0x2020,0xFE40,0x2040,0x0020,0x0000,0x0000,	//1d
	0x0000,0x1010,0x3838,0x1054,0x1010,0x1010,0x0010,0x0000,	//1e
	0x0000,0x1010,0x1010,0x5410,0x3854,0x1038,0x0010,0x0000,	//1f
	0x8000,0x4080,0x2040,0x1020,0x0810,0x0408,0x0204,0x0002,	//80
	0x6000,0x0CDA,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,	//81
	0x1000,0x1010,0x1010,0x0010,0x1000,0x1010,0x1010,0x0010,	//82
	0x1000,0x3C10,0x2460,0x1C28,0x5232,0x4042,0x3C62,0x0000,	//86
	0x0000,0x0000,0x1000,0x1678,0x2C1C,0x5A4A,0x3052,0x0000,	//87
	0x0000,0x0000,0x0000,0x2224,0x2222,0x4242,0x2840,0x0010,	//88
	0x0000,0x0000,0x3800,0x0004,0x621C,0x0202,0x0402,0x0008,	//89
	0x0000,0x0000,0x1000,0x1E08,0x4222,0x0804,0x1A08,0x0024,	//8a
	0x0000,0x0000,0x1200,0x6A1C,0x1C08,0x2A2A,0x2A2A,0x0010,	//8b
	0x0000,0x0000,0x0000,0x2E04,0x6632,0x1020,0x1010,0x0008,	//8c
	0x0000,0x0000,0x0000,0x5C48,0x6A6A,0x0A4A,0x080C,0x0008,	//8d
	0x0000,0x0000,0x0000,0x080E,0x3C08,0x4A4C,0x4A4A,0x0030,	//8e
	0x0000,0x0000,0x0000,0x621C,0x0202,0x0202,0x0402,0x0018,	//8f
	0x0000,0x7820,0x202E,0x361C,0x5252,0x5A4A,0x0232,0x0000,	//91
	0x0000,0x2420,0x4224,0x4242,0x4042,0x4040,0x2840,0x0010,	//92
	0x0000,0x0438,0x0000,0x423C,0x0202,0x0202,0x0C04,0x0008,	//93
	0x0000,0x0810,0x261C,0x0242,0x0404,0x0808,0x1A10,0x0024,	//94
	0x1000,0x1C16,0x0A6A,0x1C08,0x2A2A,0x4A4A,0x326A,0x0000,	//95
	0x0000,0x1202,0x543A,0x2214,0x2222,0x2222,0x0404,0x0000,	//96
	0x1000,0x3E10,0x0868,0x7C06,0x1C04,0x4020,0x2642,0x0018,	//97
	0x0000,0x0806,0x2010,0x4020,0x4040,0x3060,0x0E18,0x0000,	//98
	0x0000,0x2404,0x4E24,0x4454,0x4444,0x4444,0x284C,0x0000,	//99
	0x0000,0x623C,0x0202,0x0000,0x2000,0x4040,0x3E62,0x0000,	//9a
	0x1000,0x1010,0x483E,0x1808,0x4020,0x4040,0x3E62,0x0000,	//9b
	0x0000,0x2020,0x2020,0x4040,0x4040,0x4040,0x6440,0x0038,	//9c
	0x1000,0x7E10,0x0848,0x2C3C,0x4A4A,0x3252,0x0404,0x0008,	//9d
	0x0000,0x2400,0x7E24,0x2425,0x4844,0x4040,0x3220,0x000C,	//9e
	0x0000,0x4438,0x3008,0x4C22,0x2030,0x4040,0x2642,0x0018,	//9f
	0x1000,0x7810,0x2C20,0x2222,0x4040,0x4040,0x7260,0x005C,	//e0
	0x1000,0x1010,0x207E,0x2C20,0x6232,0x0202,0x0C02,0x0000,	//e1
	0x0000,0x3C00,0x4262,0x0202,0x0202,0x0202,0x0C04,0x0010,	//e2
	0x0000,0x7E00,0x080C,0x2010,0x4040,0x6040,0x1E22,0x0000,	//e3
	0x0000,0x1010,0x121C,0x4020,0x4040,0x4040,0x3E22,0x0000,	//e4
	0x0000,0x1010,0x227C,0x4022,0x5C44,0x2414,0x1C24,0x000A,	//e5
	0x0000,0x1A0E,0x4040,0x4040,0x4040,0x5040,0x3250,0x000C,	//e6
	0x0000,0x0808,0x2C1C,0x6A6A,0x722A,0x5656,0x0A2A,0x0004,	//e7
	0x0000,0x2020,0x6A24,0x2232,0x2424,0x6A6C,0x262A,0x0000,	//e8
	0x0000,0x1C00,0x2A34,0x4A4A,0x4A4A,0x4A4A,0x0432,0x0000,	//e9
	0x0800,0x0408,0x645E,0x4C44,0x5654,0x6466,0x1C64,0x0000,	//ea
	0x0000,0x3060,0x2410,0x2626,0x4444,0x4444,0x382C,0x0010,	//eb
	0x0000,0x043C,0x0804,0x1008,0x4A12,0x4A4A,0x300A,0x0000,	//ec
	0x0000,0x0000,0x3418,0x4424,0x0242,0x0202,0x0002,0x0000,	//ed
	0x0400,0x441E,0x4444,0x5E44,0x4C44,0x5654,0x1856,0x0000,	//ee
	0x1000,0x3E10,0x0848,0x3C0E,0x1848,0x4A2C,0x2A4A,0x0030,	//ef
	0x3000,0x0810,0x0A08,0x4E3A,0x4A4E,0x524B,0x0424,0x0004,	//f0
	0x0400,0x7E04,0x0804,0x2A3A,0x5048,0x7250,0x0E2A,0x0004,	//f1
	0x0000,0x4808,0x2A5C,0x6A2A,0x4A6A,0x5252,0x0472,0x0000,	//f2
	0x0000,0x1008,0x127C,0x1010,0x247C,0x2020,0x2622,0x0018,	//f3
	0x0000,0x4400,0x5C44,0x6222,0x2222,0x1012,0x0810,0x0008,	//f4
	0x0000,0x5C08,0x6A6A,0x4A4A,0x4A4A,0x0C4A,0x0808,0x0000,	//f5
	0x0800,0x0E08,0x0808,0x3C08,0x4A6C,0x4A4A,0x3048,0x0000,	//f6
	0x0000,0x0418,0x2020,0x4440,0x625E,0x0202,0x0202,0x0004,	//f7
	0x0000,0x2200,0x4242,0x4242,0x4242,0x2252,0x0406,0x0000,	//f8
	0x0000,0x4C3C,0x1008,0x362C,0x4242,0x261A,0x2422,0x0018,	//f9
	0x0000,0x2020,0x6A26,0x3272,0x2422,0x6464,0x2224,0x0000,	//fa
	0x0000,0x443C,0x1008,0x223C,0x4242,0x0202,0x0402,0x000C,	//fb
	0x0000,0x1010,0x7C10,0x1232,0x2232,0x6262,0x2422,0x0000,	//fc
	0x0000,0x1010,0x2030,0x2820,0x3434,0x2424,0x4624,0x0044,	//fd
};

//---------------------------------------------------------------------------
//
//	tHgf[^(12x12)
//
//---------------------------------------------------------------------------
const WORD CGROM::Font12x12[0x198] = {
	0x0000,0x0038,0x0064,0x0030,0x0008,0x0045,		// 1
	0x203B,0x2002,0xA003,0x2002,0x4002,0x0000,
	0x0000,0x0038,0x0064,0x0030,0x0008,0x2044,		// 2
	0x403B,0x8001,0xC000,0x4001,0x2002,0x0000,
	0x0000,0x007C,0x0020,0x0078,0x0040,0x2044,		// 3
	0x403B,0x8001,0xC000,0x4001,0x2002,0x0000,
	0x0000,0x007C,0x0020,0x0078,0x0040,0xE045,		// 4
	0x803A,0x8000,0x8000,0x8000,0x8000,0x0000,
	0x0000,0x007C,0x0020,0x0078,0x0040,0xC044,		// 5
	0x203B,0x2002,0xA002,0x4002,0xA001,0x0000,
	0x0000,0x0018,0x0028,0x0044,0x007C,0x2045,		// 6
	0x4045,0x8001,0x8001,0x4001,0x2001,0x0000,
	0x0000,0x0038,0x0064,0x0048,0x0044,0x0044,		// 7
	0x005A,0x0002,0x0002,0x2001,0xC001,0x0000,
	0x0000,0x0038,0x0064,0x0048,0x0044,0xC045,		// 8
	0x205B,0x8001,0x4000,0x2002,0xC001,0x0000,
	0x0000,0x0020,0x0064,0x0044,0x0074,0xE045,		// 9
	0x804A,0x8000,0x8000,0x8000,0x8000,0x0000,
	0x0000,0x0040,0x0040,0x0040,0x0040,0xE025,		// a
	0x003B,0x0002,0xC003,0x0002,0x0002,0x0000,
	0x0000,0x0040,0x0044,0x0044,0x0064,0xE029,		// b
	0x803A,0x8010,0x8000,0x8000,0x8000,0x0000,
	0x0000,0x003C,0x0060,0x0040,0x0078,0xE041,		// c
	0x0043,0x0002,0xC003,0x0002,0x0002,0x0000,
	0x0000,0x0038,0x0064,0x0040,0x0040,0xC045,		// d
	0x203B,0x2002,0x6002,0xC002,0x2002,0x0000,
	0x0000,0x0038,0x0064,0x0030,0x0008,0xC044,		// e
	0x203B,0x2002,0x2002,0x4003,0x8001,0x0000,
	0x0000,0x0038,0x0064,0x0030,0x0008,0xC045,		// f
	0x8038,0x8000,0x8000,0x8001,0xC000,0x0000,
	0x0000,0x0038,0x006C,0x0044,0x0044,0xE047,		//10
	0x0059,0xC003,0x0002,0x2002,0xC001,0x0000,
	0x0000,0x0038,0x006C,0x0044,0x0044,0x4044,		//11
	0xC058,0x4000,0xC000,0x8000,0xC001,0x0000,
	0x0000,0x0038,0x006C,0x0044,0x0044,0xC044,		//12
	0x6059,0x4000,0x8000,0x0001,0xC001,0x0000,
	0x0000,0x0038,0x006C,0x0044,0x0044,0xC044,		//13
	0x2059,0x4000,0x2000,0x2000,0xC001,0x0000,
	0x0000,0x0038,0x006C,0x0044,0x0044,0x0045,		//14
	0x4059,0x4002,0x8002,0xC001,0x8000,0x0000,
	0x0000,0x0044,0x0064,0x0074,0x0054,0x205D,		//15
	0x4049,0x8001,0x8001,0x4001,0x2001,0x0000,
	0x0000,0x0038,0x0064,0x0030,0x0008,0x2046,		//16
	0x203B,0xA003,0xA002,0xE002,0x4002,0x0000,
	0x0000,0x007C,0x0020,0x0078,0x0040,0xC045,		//17
	0x203B,0x4002,0x2002,0x2002,0xC002,0x0000,
	0x0000,0x0038,0x0064,0x0040,0x0040,0x2046,		//18
	0x203B,0xA003,0xA002,0xE002,0x4002,0x0000,
	0x0000,0x007C,0x0020,0x0078,0x0040,0x0046,		//19
	0x603B,0xE003,0xA002,0x2002,0x2002,0x0000,
	0x0000,0x0038,0x0064,0x0030,0x0008,0xC045,		//1a
	0x203B,0x4002,0x2002,0x2002,0xC002,0x0000,
	0x0000,0x007C,0x0020,0x0078,0x0040,0xC045,		//1b
	0x203B,0x0002,0x0002,0x2002,0xC001,0x0000,
	0x0000,0x0000,0x0000,0x8000,0x4000,0x2000,		//1c
	0xF07F,0x2000,0x4000,0x8000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0008,0x0010,0x0020,		//1d
	0xF07F,0x0020,0x0010,0x0008,0x0000,0x0000,
	0x0000,0x0004,0x000E,0x0015,0x8024,0x0004,		//1e
	0x0004,0x0004,0x0004,0x0004,0x0004,0x0000,
	0x0000,0x0004,0x0004,0x0004,0x0004,0x0004,		//1f
	0x0004,0x8024,0x0015,0x000E,0x0004,0x0000,
	0x0008,0x000C,0x0004,0x0006,0x0002,0x0003,		//80
	0x0001,0x8001,0x8000,0xC000,0x4000,0x0000,
	0x100E,0x601B,0xC020,0x0000,0x0000,0x0000,		//81
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0002,0x0002,0x0002,0x0002,0x0000,		//82
	0x0000,0x0002,0x0002,0x0002,0x0002,0x0000
};

//---------------------------------------------------------------------------
//
//	tHgf[^(12x24)
//
//---------------------------------------------------------------------------
const WORD CGROM::Font12x24[0x330] = {
	0x0000,0x0000,0x0000,0x0000,0x0038,0x0064,		// 1
	0x0040,0x0020,0x0018,0x000C,0x0044,0x0038,
	0x0001,0x2003,0x2002,0x2002,0xA003,0x2002,
	0x2002,0x4001,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0038,0x0064,		// 2
	0x0040,0x0020,0x0018,0x000C,0x0044,0x0038,
	0x2002,0x6003,0xC001,0x8000,0xC000,0x4001,
	0x2003,0x2002,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x007C,0x0020,		// 3
	0x0020,0x0078,0x0040,0x0040,0x0044,0x0038,
	0x2002,0x6003,0xC001,0x8000,0xC000,0x4001,
	0x2003,0x2002,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x007C,0x0020,		// 4
	0x0020,0x0078,0x0040,0x0040,0x0044,0x0038,
	0xE001,0x8002,0x8000,0x8000,0x8000,0x8000,
	0x8000,0x8000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x007C,0x0020,		// 5
	0x0020,0x0078,0x0040,0x0040,0x0044,0x0038,
	0xC000,0x2003,0x2002,0x2002,0xA002,0xE002,
	0x4003,0xA001,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0018,0x0028,		// 6
	0x0064,0x0044,0x007C,0x0044,0x0044,0x0044,
	0x2002,0x4002,0x8002,0x8003,0x0003,0x8002,
	0x4002,0x2002,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0038,0x0064,		// 7
	0x0044,0x0048,0x0058,0x0044,0x0044,0x0058,
	0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,
	0x2003,0xC001,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0038,0x0064,		// 8
	0x0044,0x0048,0x0058,0x0044,0x0044,0x0058,
	0xC001,0x2003,0x0002,0x0001,0xC000,0x6000,
	0x2002,0xC001,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0020,0x0064,		// 9
	0x0044,0x0044,0x0074,0x0044,0x0044,0x0028,
	0xE001,0x8002,0x8000,0x8000,0x8000,0x8000,
	0x8000,0x8000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0040,0x0040,		// a
	0x0040,0x0040,0x0040,0x0040,0x0064,0x0038,
	0xE001,0x0003,0x0002,0x8003,0xC002,0x0002,
	0x0002,0x0002,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0040,0x0044,		// b
	0x0044,0x0044,0x0064,0x0028,0x0038,0x0010,
	0xE001,0x8002,0x8000,0x8000,0x8000,0x8000,
	0x8000,0x8000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x003C,0x0060,		// c
	0x0040,0x0070,0x0058,0x0040,0x0040,0x0040,
	0xE001,0x0003,0x0002,0x8003,0xC002,0x0002,
	0x0002,0x0002,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0038,0x0064,		// d
	0x0040,0x0040,0x0040,0x0040,0x0044,0x0038,
	0xC001,0x2003,0x2002,0x2002,0x6002,0xC002,
	0x2002,0x2002,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0038,0x0064,		// e
	0x0040,0x0020,0x0018,0x000C,0x0044,0x0038,
	0xC000,0x2003,0x2002,0x2002,0x2002,0x2002,
	0x4003,0x8001,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0038,0x0064,		// f
	0x0040,0x0020,0x0018,0x000C,0x0044,0x0038,
	0xC001,0x8000,0x8000,0x8000,0x8000,0x8000,
	0x8001,0xC000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0038,0x006C,		//10
	0x0044,0x0044,0x0044,0x0044,0x0044,0x0058,
	0x0000,0xE003,0x0001,0x0001,0xC003,0x0002,
	0x0002,0x2002,0xC001,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0038,0x006C,		//11
	0x0044,0x0044,0x0044,0x0044,0x0044,0x0058,
	0x0000,0x8000,0x8001,0x8000,0x8000,0x0001,
	0x0001,0x8003,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0038,0x006C,		//12
	0x0044,0x0044,0x0044,0x0044,0x0044,0x0058,
	0xC000,0x2001,0x2000,0x4000,0x8000,0x8000,
	0x0001,0xC003,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0038,0x006C,		//13
	0x0044,0x0044,0x0044,0x0044,0x0044,0x0058,
	0xE001,0x2000,0x4000,0xC000,0x2000,0x2000,
	0x4002,0x8001,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0038,0x006C,		//14
	0x0044,0x0044,0x0044,0x0044,0x0044,0x0058,
	0x8000,0x0001,0x4001,0x4002,0x4002,0xE001,
	0x8000,0x8000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0044,0x0044,		//15
	0x0044,0x0064,0x0074,0x0054,0x005C,0x0048,
	0x2002,0x4002,0x8002,0x8003,0x0003,0x8002,
	0x4002,0x2002,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0038,0x0064,		//16
	0x0040,0x0020,0x0018,0x000C,0x0044,0x0038,
	0x2002,0x2002,0x2002,0x2003,0xA003,0xA002,
	0xE002,0x4002,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x007C,0x0020,		//17
	0x0020,0x0078,0x0040,0x0040,0x0044,0x0038,
	0xC001,0x2003,0x2002,0x4002,0xC002,0x2002,
	0x2002,0xC002,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0038,0x0064,		//18
	0x0040,0x0040,0x0040,0x0040,0x0044,0x0038,
	0x2002,0x2002,0x2002,0x2003,0xA003,0xA002,
	0xE002,0x4002,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x007C,0x0020,		//19
	0x0020,0x0078,0x0040,0x0040,0x0044,0x0038,
	0x0002,0x6003,0xE003,0xA002,0x2002,0x2002,
	0x2002,0x2002,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0038,0x0064,		//1a
	0x0040,0x0020,0x0018,0x000C,0x0044,0x0038,
	0xC001,0x2003,0x2002,0x4002,0xC002,0x2002,
	0x2002,0xC002,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x007C,0x0020,		//1b
	0x0020,0x0078,0x0040,0x0040,0x0044,0x0038,
	0xC001,0x2003,0x0002,0x0002,0x0002,0x0002,
	0x2002,0xC001,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,		//1c
	0x0000,0x0000,0x0000,0x0001,0x8000,0x4000,
	0xE07F,0x4000,0x8000,0x0001,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,		//1d
	0x0000,0x0000,0x0000,0x0008,0x0010,0x0020,
	0xE07F,0x0020,0x0010,0x0008,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0004,		//1e
	0x000E,0x0015,0x8024,0x0004,0x0004,0x0004,
	0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,
	0x0004,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0004,		//1f
	0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,
	0x0004,0x0004,0x0004,0x8024,0x0015,0x000E,
	0x0004,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0030,0x0030,0x0030,0x0018,		//80
	0x0018,0x0018,0x000C,0x000C,0x000C,0x0006,
	0x0006,0x0006,0x0003,0x0003,0x0003,0x8001,
	0x8001,0x8001,0xC000,0xC000,0xC000,0x0000,
	0x0000,0x101C,0x303B,0xE061,0xC040,0x0000,		//81
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0006,0x0006,0x0006,0x0006,0x0006,		//82
	0x0006,0x0006,0x0006,0x0006,0x0000,0x0000,
	0x0000,0x0000,0x0006,0x0006,0x0006,0x0006,
	0x0006,0x0006,0x0006,0x0006,0x0006,0x0000
};

//---------------------------------------------------------------------------
//
//	tHgf[^(16x16)
//
//---------------------------------------------------------------------------
const WORD CGROM::Font16x16[0x200] = {
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0xFFFF,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0xFF01,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x00FF,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x00FF,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0xFF01,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0xFF01,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0xFFFF,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x00FF,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0xFFFF,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0xFFFF,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0xFFFF,
	0xFFFF,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0xFF01,
	0xFF01,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x80FF,
	0x80FF,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x80FF,
	0x80FF,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0xFF01,
	0xFF01,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0xFF01,
	0xFF01,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0xFFFF,
	0xFFFF,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x80FF,
	0x80FF,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0xFFFF,
	0xFFFF,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0xFFFF,
	0xFFFF,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0xFF01,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0xFFFF,
	0xFFFF,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x80FF,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0xFFFF,
	0xFFFF,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0xFFFF,
	0xFFFF,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0xFF01,
	0xFF01,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0xFFFF,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x00FF,
	0x00FF,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0xFFFF,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0xFFFF,
	0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001,0x8001
};

//---------------------------------------------------------------------------
//
//	tHgf[^(24x24)
//
//---------------------------------------------------------------------------
const WORD CGROM::Font24x24[0x480] = {
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0xFF00,0xFFFF,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,
	0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0xFF1F,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0xFF00,0x00F0,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,
	0xFF00,0x00F0,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,
	0x0000,0xFF1F,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,
	0x0000,0xFF1F,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0xFF00,0xFFFF,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,
	0xFF00,0x00F0,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,
	0xFF00,0xFFFF,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,
	0xFF00,0xFFFF,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF,0x00FF,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,
	0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x3F00,
	0x00FF,0xFF3F,0x3F00,0x00FF,0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0xF8FF,
	0xFF00,0x00F8,0xF8FF,0x0000,0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0xF8FF,
	0xFF00,0x00F8,0xF8FF,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3F00,
	0x00FF,0xFF3F,0x3F00,0x00FF,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3F00,
	0x00FF,0xFF3F,0x3F00,0x00FF,0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF,0x00FF,0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0xF8FF,
	0xFF00,0x00F8,0xF8FF,0x0000,0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF,0x00FF,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF,0x00FF,0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,
	0x0000,0xFF3F,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF,0x00FF,0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,
	0xFF00,0x00F8,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF,0x00FF,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF,0x00FF,0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1F00,
	0x00FF,0xFF1F,0x1F00,0x00FF,0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0xFF00,0xFFFF,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0xF0FF,
	0xFF00,0x00F0,0xF0FF,0x0000,0x0010,0x1000,0x0000,0x0010,
	0x1000,0x0000,0x0010,0x1000,0x0000,0x0010,0x1000,0x0000,
	0x0010,0x1000,0x0000,0x0010,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,
	0xFF00,0xFFFF,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,
	0xFF00,0xFFFF,0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,
	0x3800,0x0000,0x0038,0x3800,0x0000,0x0038,0x3800,0x0000,
	0x0038,0x3800,0x0000,0x0038
};

//---------------------------------------------------------------------------
//
//	p쐬̂߂̑Spe[u
//
//---------------------------------------------------------------------------
LPCTSTR CGROM::HankakuTable[14] = {
	_T("@Ihfij{C|D^"),
	_T("OPQRSTUVWXGFH"),
	_T("`abcdefghijklmn"),
	_T("opqrstuvwxymnOQ"),
	_T("e"),
	_T("obpP@"),
	_T("@@@@@@"),
	_T("@"),
	_T("@BuvAE@BDFHb"),
	_T("[ACEGIJLNPRTVXZ\"),
	_T("^`cegijklmnqtwz}"),
	_T("~JK"),
	_T("ĂƂȂɂʂ˂̂͂Ђӂւق"),
	_T("݂ނ߂@@")
};

//---------------------------------------------------------------------------
//
//	SpOe[u
//
//---------------------------------------------------------------------------
const int CGROM::ExceptTable[36] = {
	0x0f, 0x1a, 0x22, 0x2a, 0x31, 0x3c, 0x4b, 0x52, 0x5a, 0x5e, 0,
	0x01, 0x10, 0x1a, 0x21, 0x3b, 0x41, 0x5b, 0x5f, 0,
	0x54, 0x5f, 0,
	0x57, 0x5f, 0,
	0x19, 0x21, 0x39, 0x5f, 0,
	0x22, 0x31, 0x52, 0x5f, 0
};

#endif	// _WIN32
