//---------------------------------------------------------------------------
//
//	X68000 EMULATOR "XM6" UTILITY
//
//	Copyright (C) 2001-2006 ohD(ytanaka@ipc-tokai.or.jp)
//	[ FATt@CVXe ]
//
//---------------------------------------------------------------------------

#include "os.h"
#include "xm6util.h"
#include "fdi.h"
#include "fatname.h"
#include "fatfs.h"

//===========================================================================
//
//	fBNgGg
//
//===========================================================================

//---------------------------------------------------------------------------
//
//	RXgN^
//
//---------------------------------------------------------------------------
FATDirEnt::FATDirEnt(BOOL human68k)
{
	// OGgȂ(ƗIuWFNg)
	prev = NULL;
	next = NULL;

	// Gg
	dir.valid = FALSE;

	// Human68kݒ
	dir.human = human68k;
}

//---------------------------------------------------------------------------
//
//	fXgN^
//
//---------------------------------------------------------------------------
FATDirEnt::~FATDirEnt()
{
	// ƗĂ邱
	ASSERT(!prev);
	ASSERT(!next);
}

//---------------------------------------------------------------------------
//
//	ÕGgݒ
//
//---------------------------------------------------------------------------
void FASTCALL FATDirEnt::SetPrev(FATDirEnt *dirent)
{
	ASSERT(this);

	// ȂƂɃZbg邩AZbĝAǂ炩
	ASSERT( ((prev == NULL) || dirent)  ||  (prev || (dirent == NULL)) );

	// ݒ
	prev = dirent;
}

//---------------------------------------------------------------------------
//
//	ÕGg擾
//
//---------------------------------------------------------------------------
FATDirEnt* FASTCALL FATDirEnt::GetPrev() const
{
	ASSERT(this);

	// 擾
	return prev;
}

//---------------------------------------------------------------------------
//
//	̃Ggݒ
//
//---------------------------------------------------------------------------
void FASTCALL FATDirEnt::SetNext(FATDirEnt *dirent)
{
	ASSERT(this);

	// ȂƂɃZbg邩AZbĝAǂ炩
	ASSERT( ((next == NULL) || dirent)  ||  (next || (dirent == NULL)) );

	// ݒ
	next = dirent;
}

//---------------------------------------------------------------------------
//
//	̃Gg擾
//
//---------------------------------------------------------------------------
FATDirEnt* FASTCALL FATDirEnt::GetNext() const
{
	ASSERT(this);

	// 擾
	return next;
}

//---------------------------------------------------------------------------
//
//	ǂݍ
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATDirEnt::Load(const BYTE *buf)
{
	ASSERT(this);
	ASSERT(buf);

	// buf32oCgɉ(gGfBA)
	memcpy(dir.name, &buf[0x00], sizeof(dir.name));
	memcpy(dir.ext, &buf[0x08], sizeof(dir.ext));
	dir.attr = buf[0x0b];
	memcpy(dir.reserved, &buf[0x0c], sizeof(dir.reserved));
	dir.time = (WORD)((buf[0x17] << 8) | buf[0x16]);
	dir.date = (WORD)((buf[0x19] << 8) | buf[0x18]);
	dir.cluster = (WORD)((buf[0x1b] << 8) | buf[0x1a]);
	dir.size = (DWORD)buf[0x1c];
	dir.size |= (DWORD)(buf[0x1d] << 8);
	dir.size |= (DWORD)(buf[0x1e] << 16);
	dir.size |= (DWORD)(buf[0x1f] << 24);

	// t@Cl[擪0x00, 0x05, 0xe5, 0xffŖgpƂ݂Ȃ(0xff͖{Asv)
	if ((buf[0] == 0x00) || (buf[0] == 0x05) || (buf[0] == 0xe5) || (buf[0] == 0xff)) {
		dir.valid = FALSE;
	}
	else {
		dir.valid = TRUE;
	}

	return TRUE;
}

//---------------------------------------------------------------------------
//
//	
//
//---------------------------------------------------------------------------
void FASTCALL FATDirEnt::Save(BYTE *buf) const
{
	ASSERT(this);
	ASSERT(buf);

	// ̃vpeBÂ܂ܓn
	memcpy(&buf[0x00], dir.name, sizeof(dir.name));
	memcpy(&buf[0x08], dir.ext, sizeof(dir.ext));
	buf[0x0b] = dir.attr;
	memcpy(&buf[0x0c], dir.reserved, sizeof(dir.reserved));
	buf[0x16] = (BYTE)(dir.time);
	buf[0x17] = (BYTE)(dir.time >> 8);
	buf[0x18] = (BYTE)(dir.date);
	buf[0x19] = (BYTE)(dir.date >> 8);
	buf[0x1a] = (BYTE)(dir.cluster);
	buf[0x1b] = (BYTE)(dir.cluster >> 8);
	buf[0x1c] = (BYTE)(dir.size);
	buf[0x1d] = (BYTE)(dir.size >> 8);
	buf[0x1e] = (BYTE)(dir.size >> 16);
	buf[0x1f] = (BYTE)(dir.size >> 24);
}

//---------------------------------------------------------------------------
//
//	
//	b
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATDirEnt::Find(const FATName& name, int level)
{
	BYTE buf[12];

	ASSERT(this);

	// ȂAsƂ
	if (!dir.valid) {
		return FALSE;
	}

	// (8)+gq(3)+I[쐬
	memcpy(buf, dir.name, sizeof(dir.name));
	memcpy(&buf[8], dir.ext, sizeof(dir.ext));
	buf[11] = '\0';

	// tRyA
	if (memcmp(buf, name.GetNames(level), sizeof(buf)) == 0) {
		return TRUE;
	}

	return FALSE;
}

//---------------------------------------------------------------------------
//
//	JnNX^擾
//
//---------------------------------------------------------------------------
DWORD FASTCALL FATDirEnt::GetCluster() const
{
	ASSERT(this);
	ASSERT(dir.valid);

	return (DWORD)dir.cluster;
}

//---------------------------------------------------------------------------
//
//	t@CTCY擾
//
//---------------------------------------------------------------------------
DWORD FASTCALL FATDirEnt::GetSize() const
{
	ASSERT(this);
	ASSERT(dir.valid);

	return dir.size;
}

//===========================================================================
//
//	fBNgz
//
//===========================================================================

//---------------------------------------------------------------------------
//
//	RXgN^
//
//---------------------------------------------------------------------------
FATDirArray::FATDirArray()
{
	// GgȂ
	array.first = NULL;
	array.total = 0;
}

//---------------------------------------------------------------------------
//
//	fXgN^
//
//---------------------------------------------------------------------------
FATDirArray::~FATDirArray()
{
	ASSERT(!array.first);
	ASSERT(array.total == 0);
}

//---------------------------------------------------------------------------
//
//	
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATDirArray::Init(BOOL human68k, int root_entries)
{
	ASSERT(this);
	ASSERT(!array.first);
	ASSERT(array.total == 0);
	ASSERT(root_entries >= 0);

	// p[^L
	array.human = human68k;

	// [gfBNg
	if (root_entries != 0) {
		// [gfBNg(Ggő吔ɐ)
		array.root = TRUE;
		array.limit = root_entries;
	}
	else {
		// TufBNg(Ggő吔ɐ͂Ȃ)
		array.root = FALSE;
		array.limit = 0;
	}

	return TRUE;
}

//---------------------------------------------------------------------------
//
//	N[Abv
//
//---------------------------------------------------------------------------
void FASTCALL FATDirArray::Cleanup()
{
	FATDirEnt *entry;

	ASSERT(this);

	// AIuWFNg폜Ă
	if (array.first) {
		// IuWFNg
		ASSERT(array.total > 0);

		// ŏ̃IuWFNg폜ÃIuWFNgɎĂ
		while (array.total > 0) {
			ASSERT(array.first);

			// ̃IuWFNgL
			entry = array.first->GetNext();

			// LȃIuWFNgȂAarray.firstɓK悤ύX
			if (entry) {
				entry->SetPrev(NULL);
			}

			// ŏ̃IuWFNg폜
			array.first->SetNext(NULL);
			delete array.first;

			// ɃZbg
			array.first = entry;

			// JE^
			array.total--;
		}
	}

	ASSERT(!array.first);
	ASSERT(array.total == 0);
}

//---------------------------------------------------------------------------
//
//	ǂݍ
//
//---------------------------------------------------------------------------
BOOL FATDirArray::Load(const BYTE *buf, int entries)
{
	FATDirEnt *entry;
	FATDirEnt *last;

	ASSERT(this);
	ASSERT(buf);
	ASSERT(entries > 0);

	// [gfBNg̏ꍇAő𒴂Ȃ`FbN
	if (array.root) {
		if ((array.total + entries) > array.limit) {
			return FALSE;
		}
	}

	// ŏ1[h
	entry = new FATDirEnt(array.human);
	entry->Load(buf);
	buf += 0x20;

	// ŏ1́AGg̏ꏊlKv
	if (!array.first) {
		// ŏ̃fBNgGg
		array.first = entry;
		ASSERT(array.first->GetPrev() == NULL);
		ASSERT(array.first->GetNext() == NULL);
	}
	else {
		// Ō̃GgT
		last = array.first;
		while (last->GetNext() != NULL) {
			last = last->GetNext();
		}

		// Ō̃Ggɒǉ
		last->SetNext(entry);
		entry->SetPrev(last);
	}

	// ǉ̂AŌ̃GgɂȂ
	last = entry;
	entries--;
	array.total++;

	// [v
	while (entries > 0) {
		// 쐬ƃ[h
		entry = new FATDirEnt(array.human);
		entry->Load(buf);
		buf += 0x20;

		// Ō̃Ggɒǉ
		last->SetNext(entry);
		entry->SetPrev(last);

		// ǉ̂AŌ̃GgɂȂ
		last = entry;
		entries--;
		array.total++;
	}

	return TRUE;
}

//---------------------------------------------------------------------------
//
//	
//	OɁAǂݍ߂Ă邱(K݂邱)
//
//---------------------------------------------------------------------------
void FASTCALL FATDirArray::Save(int index, BYTE *buf) const
{
	FATDirEnt *entry;

	ASSERT(this);
	ASSERT((index >= 0) && (index < array.total));
	ASSERT(buf);

	// oN𗘗pāAړĨGg𓾂
	entry = array.first;
	while (index > 0) {
		ASSERT(entry);
		entry = entry->GetNext();
		index--;
	}

	// Gg֎w
	ASSERT(entry);
	entry->Save(buf);
}

//---------------------------------------------------------------------------
//
//	
//
//---------------------------------------------------------------------------
FATDirEnt* FASTCALL FATDirArray::Find(const FATName& name, int level)
{
	FATDirEnt *entry;

	ASSERT(this);
	ASSERT(level >= 0);

	// 
	entry = array.first;

	// [v
	while (entry) {
		// gC
		if (entry->Find(name, level)) {
			// 
			return entry;
		}

		// 
		entry = entry->GetNext();
	}

	// Ȃ
	return NULL;
}

//===========================================================================
//
//	FAT`FC
//
//===========================================================================

//---------------------------------------------------------------------------
//
//	RXgN^
//
//---------------------------------------------------------------------------
FATChain::FATChain()
{
	// 
	chain.fat = NULL;
	chain.clusters = 0;
	chain.bytes = 0;
}

//---------------------------------------------------------------------------
//
//	fXgN^
//
//---------------------------------------------------------------------------
FATChain::~FATChain()
{
	ASSERT(!chain.fat);
}

//---------------------------------------------------------------------------
//
//	
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATChain::Init(int cls, int bts)
{
	int i;

	ASSERT(this);
	ASSERT(cls > 0);
	ASSERT(bts > 0);
	ASSERT((bts & 0x1ff) == 0);
	ASSERT(!chain.fat);
	ASSERT(!chain.clusters);
	ASSERT(!chain.bytes);

	// fBXN̎NX^ƁA1NX^̃oCg^
	chain.clusters = cls;
	chain.bytes = bts;

	// NX^4085ȉFAT12AȏFAT16
	if (chain.clusters <= 4085) {
		// FAT12
		chain.bits = 12;
	}
	else {
		// FAT16
		chain.bits = 16;
	}

	// FATGg̈Ӗ
	if (chain.bits == 16) {
		// 16bit FAT
		chain.f_free = 0x0000;
		chain.f_rsv = 0x0001;
		chain.f_min = 0x0003;
		chain.f_max = 0xfff6;
		chain.f_bad = 0xfff7;
		chain.f_eofmin = 0xfff8;
		chain.f_eofmax = 0xffff;
	}
	else {
		// 12bit FAT
		chain.f_free = 0x000;
		chain.f_rsv = 0x001;
		chain.f_min = 0x003;
		chain.f_max = 0xff6;
		chain.f_bad = 0xff7;
		chain.f_eofmin = 0xff8;
		chain.f_eofmax = 0xfff;
	}

	// (LNX^+2)FATobt@m
	try {
		chain.fat = new DWORD[chain.clusters + 2];
	}
	catch (...) {
		chain.fat = NULL;
	}
	if (!chain.fat) {
		return FALSE;
	}

	// FATobt@𖢎gpɏ
	for (i=0; i<chain.clusters; i++) {
		chain.fat[i] = chain.f_free;
	}

	return TRUE;
}

//---------------------------------------------------------------------------
//
//	N[Abv
//
//---------------------------------------------------------------------------
void FASTCALL FATChain::Cleanup()
{
	ASSERT(this);

	// FATobt@Lł΁A
	if (chain.fat) {
		delete[] chain.fat;
		chain.fat = NULL;
	}
}

//---------------------------------------------------------------------------
//
//	ǂݍ
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATChain::Load(const BYTE *buf, DWORD length)
{
	int i;
	BOOL flag;
	DWORD data;

	ASSERT(this);
	ASSERT(chain.clusters > 0);
	ASSERT(chain.bytes > 0);
	ASSERT((chain.bits == 12) || (chain.bits == 16));
	ASSERT(buf);
	ASSERT(length > 0);
	ASSERT((length & 0x1ff) == 0);
	ASSERT(length <= 0x20000);

	// FATʎq̃`FbN(FAT12, FAT16ƂA擪FE FF FF)
	if (buf[0] != 0xfe) {
		return FALSE;
	}
	if (buf[1] != 0xff) {
		return FALSE;
	}
	if (buf[2] != 0xff) {
		return FALSE;
	}
	// FAT16́A擪FE FF FF FF
	if (chain.bits == 16) {
		if (buf[3] != 0xff) {
			return FALSE;
		}
	}

	// |C^ʎqi߂
	if (chain.bits == 16) {
		buf += 4;
	}
	else {
		ASSERT(chain.bits == 12);
		buf += 3;
	}

	// FAT12tO
	flag = TRUE;

	for (i=0; i<chain.clusters; i++) {
		// FAT12EFAT16ŕ
		if (chain.bits == 16) {
			// FAT16̓Vv(gGfBA)
			data = (DWORD)((buf[1] << 8) | buf[0]);
			buf += 2;
		}
		else {
			// FAT12̓tOɂĕ
			if (flag) {
				// O^Cv
				data = (DWORD)(((buf[1] & 0x0f) << 8) | buf[0]);
				flag = FALSE;
			}
			else {
				// 㔼^Cv
				data = (DWORD)((buf[2] << 4) | (buf[1] >> 4));
				flag = TRUE;

				// 㔼^CvɁA|C^XV
				buf += 3;
			}
		}

		// f_eofmax𒴂ĺAFATƂĂ
		if (data > chain.f_eofmax) {
			return FALSE;
		}

		// FATݒ
		chain.fat[i + 2] = data;
	}

	return TRUE;
}

//---------------------------------------------------------------------------
//
//	Ō̃NX^
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATChain::IsLast(DWORD cluster)
{
	ASSERT(this);
	ASSERT(chain.clusters > 0);
	ASSERT(cluster < (DWORD)(chain.clusters + 2));
	ASSERT(chain.fat);
	ASSERT(cluster >= 2);

	// lĔf
	if ((chain.f_eofmin <= chain.fat[cluster]) && (chain.fat[cluster] <= chain.f_eofmax)) {
		// cluster͍Ō̃NX^
		return TRUE;
	}

	// ł͂Ȃ
	return FALSE;
}

//---------------------------------------------------------------------------
//
//	̃NX^擾
//
//---------------------------------------------------------------------------
DWORD FASTCALL FATChain::GetNext(DWORD cluster)
{
	ASSERT(this);
	ASSERT(chain.clusters > 0);
	ASSERT(cluster < (DWORD)(chain.clusters + 2));
	ASSERT(chain.fat);
	ASSERT(cluster >= 2);

	// lĔf
	if ((chain.f_min <= chain.fat[cluster]) && (chain.fat[cluster] <= chain.f_max)) {
		// l
		return chain.fat[cluster];
	}

	// sǃNX^A邢́At@CVXesȂ̂ŁA̒lԂ
	return chain.f_rsv;
}

//---------------------------------------------------------------------------
//
//	ȃNX^ԍ
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATChain::IsValid(DWORD cluster) const
{
	ASSERT(this);
	ASSERT(chain.clusters > 0);

	// f_free, f_bad, f_rsvُ͈Ɣf
	if ((cluster == chain.f_free) || (cluster == chain.f_bad) || (cluster == chain.f_rsv)) {
		return FALSE;
	}

	// ȊOOK
	return TRUE;
}

//===========================================================================
//
//	FATt@CVXe
//
//===========================================================================

//---------------------------------------------------------------------------
//
//	RXgN^
//
//---------------------------------------------------------------------------
FATFs::FATFs()
{
	// [N
	memset(&fs, 0, sizeof(fs));

	// A^b`Ȃ
	fs.attached = FALSE;
	fs.disk = NULL;

	// I[vȂ
	fs.opened = FALSE;
	fs.openarray = NULL;
	fs.openentry = NULL;

	// IuWFNgȂ
	fs.dir = NULL;
	fs.fat = NULL;

	// obt@Ȃ
	buffer = NULL;
}

//---------------------------------------------------------------------------
//
//	fXgN^
//
//---------------------------------------------------------------------------
FATFs::~FATFs()
{
	// I[vĂȂ
	ASSERT(!fs.opened);
	ASSERT(!fs.openarray);
	ASSERT(!fs.openentry);

	// A^b`ĂȂ
	ASSERT(!fs.attached);
	ASSERT(!fs.disk);

	// obt@Ă邱
	ASSERT(!buffer);
}

//---------------------------------------------------------------------------
//
//	A^b`
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATFs::Attach(const Filepath& path, DWORD type)
{
	ASSERT(this);

	// A^b`ĂȂ
	ASSERT(!fs.attached);
	ASSERT(!fs.disk);
	ASSERT(!fs.dir);
	ASSERT(!buffer);

	// Human68ktO𗎂ƂĂ
	fs.human = FALSE;

	// ^Cv
	switch (type) {
		// 1.25MB (Human68k)
		case FST_HUMAN:
			// FDIIuWFNg쐬AI[v
			fs.disk = new FDIDisk2HD(0, NULL);
			if (!fs.disk->Open(path)) {
				// t@CȂATCYُ
				fs.disk = NULL;
				return FALSE;
			}

			// WIgݒ(1.25MB 2HD)
			fs.media = 0xfe;
			fs.tracks = 154;
			fs.sectors = 8;
			fs.seclen = 0x400;
			fs.units = 1;
			fs.clusters = 1221;
			fs.reserved = 1;
			fs.fats = 2;
			fs.fatsecs = 2;
			fs.rootdirs = 192;

			// Human68ktO
			fs.human = TRUE;
			break;

		// ȊÕ^Cv̓T|[gĂȂ
		default:
			ASSERT(FALSE);
			return FALSE;
	}

	// ŁAobt@m(0x20000́AFAT16ɑΉőFATTCY)
	try {
		buffer = new BYTE[0x20000];
	}
	catch (...) {
		buffer = NULL;
	}
	if (!buffer) {
		// obt@mێsBfBXN
		delete fs.disk;
		fs.disk = NULL;
		return FALSE;
	}

	// FATǂݍ
	if (!LoadFAT()) {
		// FATǂݍݎsBobt@EfBXN
		delete[] buffer;
		buffer = NULL;
		delete fs.disk;
		fs.disk = NULL;
		return FALSE;
	}

	// [gfBNg쐬Aǂݍ
	if (!LoadRootDir()) {
		// [gfBNgǂݍݎsBFATEobt@EfBXN
		fs.fat->Cleanup();
		delete fs.fat;
		fs.fat = NULL;
		delete[] buffer;
		buffer = NULL;
		delete fs.disk;
		fs.disk = NULL;
		return FALSE;
	}

	// A^b`ς
	ASSERT(fs.disk);
	fs.attached = TRUE;

	return TRUE;
}

//---------------------------------------------------------------------------
//
//	f^b`
//
//---------------------------------------------------------------------------
BOOL FASTCALL::FATFs::Detach()
{
	BOOL flush;

	ASSERT(this);

	// A^b`ĂȂ΁AȂ
	if (!fs.attached) {
		return TRUE;
	}

	// I[vĂȂ
	ASSERT(!fs.opened);
	ASSERT(!fs.openarray);
	ASSERT(!fs.openentry);

	// [gfBNg폜
	fs.dir->Cleanup();
	delete fs.dir;
	fs.dir = NULL;

	// FAT폜
	fs.fat->Cleanup();
	delete fs.fat;
	fs.fat = NULL;

	// obt@폜
	delete[] buffer;
	buffer = NULL;

	// fBXNLbVtbV
	ASSERT(fs.disk);
	flush = fs.disk->Flush();

	// fBXN폜
	delete fs.disk;
	fs.disk = NULL;

	// A^b`Ȃ
	fs.attached = FALSE;

	// tbVʂԂ
	return flush;
}

//---------------------------------------------------------------------------
//
//	FAT[h
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATFs::LoadFAT()
{
	int sector;

	ASSERT(this);
	ASSERT(!fs.fat);
	ASSERT(fs.fatsecs > 0);

	// FATIuWFNg쐬(NX^A1NX^̃oCgw)
	fs.fat = new FATChain;
	if (!fs.fat->Init(fs.clusters, fs.units * fs.seclen)) {
		fs.fat->Cleanup();
		delete fs.fat;
		fs.fat = NULL;
		return FALSE;
	}

	// ZN^[v
	for (sector=0; sector<fs.fatsecs; sector++) {
		// FATZN^ėpobt@֓ǂݍ
		if (!LoadFATSector(sector)) {
			// ǂݍݎs
			fs.fat->Cleanup();
			delete fs.fat;
			fs.fat = NULL;
			return FALSE;
		}
	}

	// FATIuWFNgփ[h
	if (!fs.fat->Load(buffer, fs.seclen * fs.sectors)) {
		// [hs
		fs.fat->Cleanup();
		delete fs.fat;
		fs.fat = NULL;
		return FALSE;
	}

	// 
	return TRUE;
}

//---------------------------------------------------------------------------
//
//	FATZN^[h
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATFs::LoadFATSector(int sector)
{
	ASSERT(this);
	ASSERT(fs.disk);
	ASSERT((sector >= 0) && (sector < fs.fatsecs));

	// [h(\ZN^)
	return ReadSector(sector + fs.reserved, &buffer[sector * fs.seclen]);
}

//---------------------------------------------------------------------------
//
//	[gfBNg[h
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATFs::LoadRootDir()
{
	int sector;
	int sectors;

	ASSERT(this);
	ASSERT(!fs.dir);

	// fBNgzIuWFNg쐬(Human68ktOA[gtOn)
	fs.dir = new FATDirArray;
	if (!fs.dir->Init(fs.human, fs.rootdirs)) {
		fs.dir->Cleanup();
		delete fs.dir;
		fs.dir = NULL;
		return FALSE;
	}

	// Kvȓǂݍ݃ZN^Zo
	sectors = (fs.rootdirs * 0x20) / fs.seclen;

	// JnZN^Zo(\ZN^ƁAFAT~n̎)
	sector = fs.reserved + (fs.fats * fs.fatsecs);

	// [v
	while (sectors > 0) {
		// ZN^ǂݍ
		if (!ReadSector(sector, buffer)) {
			fs.dir->Cleanup();
			delete fs.dir;
			fs.dir = NULL;
			return FALSE;
		}

		// fBNgzփ[h(KAǉɂȂ)
		if (!fs.dir->Load(buffer, (fs.seclen / 0x20))) {
			fs.dir->Cleanup();
			delete fs.dir;
			fs.dir = NULL;
			return FALSE;
		}

		// 
		sector++;
		sectors--;
	}

	// I
	return TRUE;
}

//---------------------------------------------------------------------------
//
//	[gfBNg𕡎
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATFs::DuplicateDir()
{
	int i;
	BYTE buf[0x20];

	ASSERT(this);
	ASSERT(fs.dir);
	ASSERT(!fs.openarray);

	// fBNgzIuWFNg쐬(Human68ktOA[gtOn)
	fs.openarray = new FATDirArray;
	if (!fs.openarray->Init(fs.human, fs.rootdirs)) {
		fs.openarray->Cleanup();
		delete fs.openarray;
		fs.openarray = NULL;
		return FALSE;
	}

	// Ƀ[gfBNgŜ[hłĂ͂Ȃ̂ŁAGgƃRs[
	for (i=0; i<fs.rootdirs; i++) {
		// Ggǂݎ
		fs.dir->Save(i, buf);

		// Gg
		if (!fs.openarray->Load(buf, 1)) {
			fs.openarray->Cleanup();
			delete fs.openarray;
			fs.openarray = NULL;
			return FALSE;
		}
	}

	return TRUE;
}

//---------------------------------------------------------------------------
//
//	TufBNg[h
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATFs::LoadSubDir(DWORD cluster)
{
	int num;

	ASSERT(this);
	ASSERT(!fs.openarray);
	ASSERT(cluster >= 2);
	ASSERT(cluster < (DWORD)(fs.clusters + 2));

	// fBNgzIuWFNg쐬(Human68ktOn)
	fs.openarray = new FATDirArray;
	if (!fs.openarray->Init(fs.human)) {
		fs.openarray->Cleanup();
		delete fs.openarray;
		fs.openarray = NULL;
		return FALSE;
	}

	// 1NX^̃fBNgGgZo
	num = (fs.units * fs.seclen) / 0x20;

	// ܂Ń[v
	while (fs.fat->IsValid(cluster)) {
		// 1NX^ǂ
		if (!ReadCluster(cluster, buffer)) {
			// fBXNǂ߂Ȃ
			fs.openarray->Cleanup();
			delete fs.openarray;
			fs.openarray = NULL;
			return FALSE;
		}

		// obt@numPʂŒǉ
		if (!fs.openarray->Load(buffer, num)) {
			fs.openarray->Cleanup();
			delete fs.openarray;
			fs.openarray = NULL;
			return FALSE;
		}

		// ̃NX^𓾂
		cluster = fs.fat->GetNext(cluster);
	}

	return TRUE;
}

//---------------------------------------------------------------------------
//
//	ėpZN^ǂݍ
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATFs::ReadSector(int sector, BYTE *buf)
{
	DWORD chrn[4];
	int len;
	int status;

	ASSERT(this);
	ASSERT(fs.disk);
	ASSERT((sector >= 0) && (sector < (fs.tracks * fs.sectors)));
	ASSERT(buf);

	// FDIDiskCHRNHDv̂ŁAϊ
	chrn[0] = sector / (fs.sectors * 2);
	chrn[1] = (sector / fs.sectors) & 1;
	chrn[2] = (sector % fs.sectors) + 1;
	switch (fs.seclen) {
		// 512oCg/ZN^(FST_2HQ, FST_2DD, FST_2D)
		case 0x200:
			chrn[3] = 0x02;
			break;

		// 1024oCg/ZN^(FST_HUMAN, FST_2HD)
		case 0x400:
			chrn[3] = 0x03;
			break;

		// ȊO(肦Ȃ)
		default:
			ASSERT(FALSE);
			return FALSE;
	}

	// ܂V[N
	fs.disk->Seek(chrn[0]);

	// ǂݍ(MFM)
	if (chrn[1] == 0) {
		// Head 0
		status = fs.disk->ReadSector(buf, &len, TRUE, chrn, 0);
	}
	else {
		// Head 1
		status = fs.disk->ReadSector(buf, &len, TRUE, chrn, 4);
	}

	// Xe[^X`FbN
	if (status != FDD_NOERROR) {
		return FALSE;
	}

	// OX`FbN
	if (len != fs.seclen) {
		return FALSE;
	}

	// 
	return TRUE;
}

//---------------------------------------------------------------------------
//
//	ėpNX^ǂݍ
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATFs::ReadCluster(DWORD cluster, BYTE *buf)
{
	int i;
	int sector;

	ASSERT(this);
	ASSERT(fs.attached);
	ASSERT((cluster >= 2) && (cluster <= (DWORD)(fs.clusters + 2)));
	ASSERT(buf);

	// NX^ԍAAZN^ԍ֕ϊ
	sector = fs.reserved;
	sector += (fs.fats * fs.fatsecs);
	sector += ((fs.rootdirs * 0x20) / fs.seclen);

	// [gfBNg̈̒オANX^2ƂȂ
	sector += ((cluster - 2) * fs.units);

	// fs.unitsǂݍ(1NX^ǂݍ)
	for (i=0; i<fs.units; i++) {
		if (!ReadSector(sector, buf)) {
			return FALSE;
		}

		// 
		buf += fs.seclen;
		sector++;
	}

	return TRUE;
}

//---------------------------------------------------------------------------
//
//	I[v
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATFs::Open(const FATName& name, OpenMode mode)
{
	int level;
	int now;
	FATDirEnt *entry;
	DWORD cluster;

	ASSERT(this);

	// ݂ReadOnlŷݑΉ
	ASSERT(fs.attached);
	ASSERT(!fs.opened);
	ASSERT(!fs.openarray);
	ASSERT(!fs.openentry);
	ASSERT(mode == ReadOnly);

	// LȖ̂łȂ΁As
	if (!name.IsValid()) {
		return FALSE;
	}

	// Kwx擾
	level = name.GetLevel();
	now = 0;

	// ݂̃[gfBNgAI[vACɕ
	if (!DuplicateDir()) {
		// oł܂Â
		return FALSE;
	}

	// fBNg[v
	while (level > 0) {
		// pX؂PʂŒTĂ
		entry = fs.openarray->Find(name, now);
		if (!entry) {
			// pXrŌ
			fs.openarray->Cleanup();
			delete fs.openarray;
			fs.openarray = NULL;
			return FALSE;
		}

		// Gg킩̂ŁAJnNX^𓾂Ă
		cluster = entry->GetCluster();

		// ŃI[vAC폜
		fs.openarray->Cleanup();
		delete fs.openarray;
		fs.openarray = NULL;

		// JnNX^肪ɁA쐬
		if (!LoadSubDir(cluster)) {
			// ̃TufBNgǂݍ߂Ȃ
			return FALSE;
		}

		// ̃xֈڂ
		ASSERT(fs.openarray);
		level--;
		now++;
	}

	// ŏIfBNg֓BBt@CT
	ASSERT(fs.openarray);
	entry = fs.openarray->Find(name, now);
	if (!entry) {
		// ŏIt@C
		fs.openarray->Cleanup();
		delete fs.openarray;
		fs.openarray = NULL;
		return FALSE;
	}

	// GgۑāAI[v
	fs.opened = TRUE;
	fs.openentry = entry;

	return TRUE;
}

//---------------------------------------------------------------------------
//
//	N[Y
//
//---------------------------------------------------------------------------
void FASTCALL FATFs::Close()
{
	ASSERT(this);

	// I[vĂȂ΁AȂ
	if (!fs.opened) {
		ASSERT(!fs.openarray);
		ASSERT(!fs.openentry);
		return;
	}

	// o[WReadOnlŷݑΉȂ̂ŁAs
	ASSERT(fs.openarray);
	ASSERT(fs.openentry);
	fs.openarray->Cleanup();
	delete fs.openarray;
	fs.openarray = NULL;

	// Gg̓AC̈ꕔȂ̂ŁAƓɏĂ
	fs.openentry = NULL;

	// I[vȂ
	fs.opened = FALSE;
}

//---------------------------------------------------------------------------
//
//	t@CTCY擾
//
//---------------------------------------------------------------------------
DWORD FASTCALL FATFs::GetSize() const
{
	ASSERT(this);

	// I[vĂȂ΁ATCY0
	if (!fs.opened) {
		return 0;
	}

	// I[vĂ΁AACƃGg
	ASSERT(fs.openarray);
	ASSERT(fs.openentry);

	// Gg擾
	return fs.openentry->GetSize();
}

//---------------------------------------------------------------------------
//
//	ǂݍ
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATFs::Read(BYTE *buf)
{
	DWORD cluster;
	DWORD length;
	DWORD size;

	ASSERT(this);

	// I[vĂȂ΁As
	if (!fs.opened) {
		return FALSE;
	}

	// I[vĂ΁AACƃGg
	ASSERT(fs.openarray);
	ASSERT(fs.openentry);

	// JnNX^ƃTCY𓾂Ă
	cluster = fs.openentry->GetCluster();
	size = fs.openentry->GetSize();

	// [v
	while (size > 0) {
		// NX^`FbN
		if (!fs.fat->IsValid(cluster)) {
			// fBNgGgFAT`FC̕sB[hs
			return FALSE;
		}

		// t@CVXẽobt@ցAUǂݍ
		if (!ReadCluster(cluster, buffer)) {
			return FALSE;
		}
		length = (DWORD)(fs.units * fs.seclen);

		// TCYlăRs[
		if (size < length) {
			length = size;
		}
		memcpy(buf, buffer, length);

		// 
		buf += length;
		size -= length;
		cluster = fs.fat->GetNext(cluster);
	}

	// 
	return TRUE;
}
