//---------------------------------------------------------------------------
//
//	X68000 EMULATOR "XM6" UTILITY
//
//	Copyright (C) 2001-2006 ohD(ytanaka@ipc-tokai.or.jp)
//	[ FATt@CVXe ]
//
//---------------------------------------------------------------------------

#if !defined(fatfs_h)
#define fatfs_h

//---------------------------------------------------------------------------
//
//	NXs`
//
//---------------------------------------------------------------------------
class FDIDisk;

class FATName;
class FATDirEnt;
class FATDirArray;
class FATChain;
class FATFs;

//---------------------------------------------------------------------------
//
//	^Cv`
//
//---------------------------------------------------------------------------
#define FST_HUMAN	MAKEID('2', 'H', 'D', 'H')	// 1.25MB (Human68k)
#define FST_2HD		MAKEID('2', 'H', 'D', 'M')	// 1.25MB (MS-DOS)
#define FST_2HC		MAKEID('2', 'H', 'C', 'M')	// 1.21MB (MS-DOS)
#define FST_2HQ		MAKEID('2', 'H', 'Q', 'M')	// 1.44MB (MS-DOS)
#define FST_2DD		MAKEID('2', 'D', 'D', 'M')	// 720KB (MS-DOS)
#define FST_2D		MAKEID('2', 'D', ' ', 'M')	// 360KB (MS-DOS)

//---------------------------------------------------------------------------
//
//	Agr[g`
//
//---------------------------------------------------------------------------
#define FSA_EXEC	0x80				// st@C(execd.x)
#define FSA_LN		0x40				// V{bNN(lndrv.x)
#define FSA_ARC		0x20				// A[JCu(ʏt@C)
#define FSA_DIR		0x10				// TufBNg
#define FSA_VOL		0x08				// {[x
#define FSA_SYS		0x04				// VXet@C
#define FSA_HID		0x02				// Bt@C
#define FSA_RO		0x01				// ǂݍݐp

//===========================================================================
//
//	fBNgGg
//
//===========================================================================
class FATDirEnt
{
public:
	// f[^`
	typedef struct {
		// MS-DOSIWi
		BOOL valid;						// LGg
		BYTE name[8];					// t@C(󂫂0x20)
		BYTE ext[3];					// gq(󂫂0x20)
		BYTE attr;						// 
		BYTE reserved[10];				// \̈
		WORD time;						// ŏIݎ
		WORD date;						// ŏIݓt
		WORD cluster;					// JnNX^ԍ
		DWORD size;						// t@CTCY

		// Human68kgtO
		BOOL human;						// Human68kgtO
	} dirent_t;

public:
	// {t@NV
	FATDirEnt(BOOL human68k);
										// RXgN^
	virtual ~FATDirEnt();
										// fXgN^

	// oN
	void FASTCALL SetPrev(FATDirEnt *dirent);
										// ÕGgݒ
	FATDirEnt* FASTCALL GetPrev() const;
										// ÕGg擾
	void FASTCALL SetNext(FATDirEnt *dirent);
										// ̃Ggݒ
	FATDirEnt* FASTCALL GetNext() const;
										// ̃Gg擾

	// [hEZ[u
	BOOL FASTCALL Load(const BYTE *buf);
										// ǂݍ
	void FASTCALL Save(BYTE *buf) const;
										// 

	// 
	BOOL FASTCALL Find(const FATName& name, int level);
										// 

	// vpeB
	DWORD FASTCALL GetCluster() const;
										// JnNX^擾
	DWORD FASTCALL GetSize() const;
										// t@CTCY擾

private:
	dirent_t dir;
										// fBNgGg
	FATDirEnt *prev;
										// ÕGg
	FATDirEnt *next;
										// ̃Gg
};

//===========================================================================
//
//	fBNgz
//
//===========================================================================
class FATDirArray
{
public:
	// f[^`
	typedef struct {
		FATDirEnt *first;				// ŏ̃fBNgGg
		int limit;						// z(ő)
		int total;						// z(v)
		BOOL root;						// [gfBNgtO
		BOOL human;						// Human68kgtO
	} dirarray_t;

public:
	// {t@NV
	FATDirArray();
										// RXgN^
	virtual ~FATDirArray();
										// fXgN^
	BOOL FASTCALL Init(BOOL human68k, int root_entries = 0);
										// 
	void FASTCALL Cleanup();
										// N[Abv

	// [hEZ[u
	BOOL FASTCALL Load(const BYTE *buf, int entries);
										// ǂݍ(ǉ)
	void FASTCALL Save(int index, BYTE *buf) const;
										// 

	// 
	FATDirEnt* FASTCALL Find(const FATName& name, int level);
										// 

private:
	dirarray_t array;
										// fBNgz
};

//===========================================================================
//
//	FAT`FC
//
//===========================================================================
class FATChain
{
public:
	// f[^`
	typedef struct {
		// FAT
		DWORD *fat;						// FATz

		// t@CVXep[^
		int clusters;					// NX^/fBXN
		int bytes;						// oCg/NX^
		int bits;						// rbg/FATf[^

		// FATGg̈Ӗ(12bitFAT, 16bitFATŕ)
		DWORD f_free;					// gpNX^
		DWORD f_rsv;					// gpl
		DWORD f_min;					// `FCŏl
		DWORD f_max;					// `FCől
		DWORD f_bad;					// sǃNX^
		DWORD f_eofmin;					// ŏINX^ŏl
		DWORD f_eofmax;					// ŏINX^ől
	} chain_t;

public:
	// {t@NV
	FATChain();
										// RXgN^
	virtual ~FATChain();
										// fXgN^
	BOOL FASTCALL Init(int cls, int bts);
										// 
	void FASTCALL Cleanup();
										// N[Abv

	// [hEZ[u
	BOOL FASTCALL Load(const BYTE *buf, DWORD length);
										// ǂݍ

	// vpeB
	BOOL FASTCALL IsLast(DWORD cluster);
										// Ō̃NX^
	DWORD FASTCALL GetNext(DWORD cluster);
										// ̃NX^擾
	BOOL FASTCALL IsValid(DWORD cluster) const;
										// ȃNX^ԍ

private:
	chain_t chain;
										// FAT`FC
};

//===========================================================================
//
//	t@CVXe
//
//===========================================================================
class FATFs
{
public:
	// I[v[h`
	enum OpenMode {
		ReadOnly,						// ǂݍ݂̂
		WriteOnly,						// ݂̂
		ReadWrite,						// ǂݏ
		Append							// Ayh
	};

public:
	// f[^`
	typedef struct {
		// {f[^
		DWORD id;						// 
		BOOL human;						// Human68ktO
		FDIDisk *disk;					// ΏۃfBXN
		BOOL attached;					// A^b`ς݃tO

		// t@CVXep[^
		DWORD media;					// fBAID
		int tracks;						// gbN
		int sectors;					// ZN^/gbN
		int seclen;						// ZN^
		int units;						// ZN^/NX^
		int clusters;					// NX^/fBXN
		int reserved;					// \ZN^
		int fats;						// FAT
		int fatsecs;					// ZN^/FAT
		int rootdirs;					// [gfBNg

		// Jgt@C
		BOOL opened;					// I[vς݃tO
		FATDirArray *openarray;			// I[vt@Cz
		FATDirEnt *openentry;			// I[vt@C̃Gg

		// [gfBNg
		FATDirArray *dir;				// [gfBNgz

		// FAT`FC
		FATChain *fat;					// FATf[^(1FAT̂)
	} fs_t;

public:
	// {t@NV
	FATFs();
										// RXgN^
	virtual ~FATFs();
										// fXgN^

	// fBXN
	BOOL FASTCALL Attach(const Filepath& path, DWORD type);
										// fBXNC[W蓖
	BOOL FASTCALL Detach();
										// fBXNC[W蓖ĉ

	// t@C
	BOOL FASTCALL Open(const FATName &name, OpenMode mode);
										// I[v
	void FASTCALL Close();
										// N[Y
	DWORD FASTCALL GetSize() const;
										// t@CTCY擾
	BOOL FASTCALL Read(BYTE *buf);
										// ǂݍ

private:
	// FAT
	BOOL FASTCALL LoadFAT();
										// FAT[h
	BOOL FASTCALL LoadFATSector(int sector);
										// FATZN^[h

	// fBNg
	BOOL FASTCALL LoadRootDir();
										// [gfBNg[h
	BOOL FASTCALL DuplicateDir();
										// [gfBNg𕡎
	BOOL FASTCALL LoadSubDir(DWORD cluster);
										// TufBNg[h

	// fBXN
	BOOL FASTCALL ReadSector(int sector, BYTE *buf);
										// AZN^ԍǂݍ
	BOOL FASTCALL ReadCluster(DWORD cluster, BYTE *buf);
										// NX^ԍǂݍ

	// [N
	BYTE *buffer;
										// ėpobt@
	fs_t fs;
										// t@CVXef[^
};

#endif	// fatfs_h
