//---------------------------------------------------------------------------
//
//	X68000 EMULATOR "XM6" UTILITY
//
//	Copyright (C) 2001-2006 ohD(ytanaka@ipc-tokai.or.jp)
//	[ FATt@Cl[ ]
//
//---------------------------------------------------------------------------

#if defined(_WIN32)

#include "os.h"
#include "xm6util.h"
#include "fatname.h"

//===========================================================================
//
//	FATt@Cl[
//
//===========================================================================

//---------------------------------------------------------------------------
//
//	RXgN^
//
//---------------------------------------------------------------------------
FATName::FATName()
{
	int i;

	// LłȂ
	valid = FALSE;

	// ẂAׂđ݂Ȃ
	for (i=0; i<LevelMax; i++) {
		names[i] = NULL;
	}
}

//---------------------------------------------------------------------------
//
//	fXgN^
//
//---------------------------------------------------------------------------
FATName::~FATName()
{
	int i;

	// W΁Aׂč폜
	for (i=0; i<LevelMax; i++) {
		if (names[i]) {
			delete[] names[i];
			names[i] = NULL;
		}
	}
}

//---------------------------------------------------------------------------
//
//	t@Cl[ݒ
//	'/DIR1/DIR2/FILENAME.EXT'̂悤ȃpX^邱
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATName::SetName(LPCTSTR lpszName)
{
	int length;
	BYTE *path;
	BYTE *first;
	BYTE *last;

	ASSERT(this);
	ASSERT(lpszName);
	ASSERT(!valid);

	// x
	level = 0;

#if defined(UNICODE)
	// UNICODȄꍇAMBCS֕ϊB̂߁A2{̃obt@p
	length = (int)_tcslen(lpszName);
	try {
		path = new BYTE[(length + 1) * 2];
	}
	catch (...) {
		path = NULL;
	}
	if (!path) {
		return FALSE;
	}
	ToMulti(lpszName, path);
#else
	// UNICODEłȂ΁APɃRs[邾ł悢
	length = (int)_tcslen(lpszName);
	try {
		path = new BYTE[(length + 1)];
	}
	catch (...) {
		path = NULL;
	}
	if (!path) {
		return FALSE;
	}
	_tcscpy((LPSTR)path, lpszName);
#endif	// UNICODE

	// 擪'/'ł邱
	if (path[0] != '/') {
		return FALSE;
	}
	first = &path[0];

	// [v
	for (;;) {
		last = GetNextSlash(first + 1);
		if (!last) {
			// ̃xŏI
			if (!CopyName(level, first + 1)) {
				// sB܂
				return FALSE;
			}
			// ŏIȂ̂ŁA
			break;
		}

		// ܂̃x
		if (!CopyName(level, first + 1)) {
			// sB܂
			return FALSE;
		}

		// xグ邪Aől𒴂Ȃ
		level++;
		if (level >= LevelMax) {
			delete[] path;
			return FALSE;
		}

		// ړ
		first = last;
	}

	// ꎞobt@폜
	delete[] path;

	// L
	valid = TRUE;
	return TRUE;
}

//---------------------------------------------------------------------------
//
//	L`FbN
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATName::IsValid() const
{
	ASSERT(this);

	return valid;
}

//---------------------------------------------------------------------------
//
//	Kwx擾
//	[gfBNgɑ݂t@Cx0Aȉx1,2..Ƃ
//
//---------------------------------------------------------------------------
int FASTCALL FATName::GetLevel() const
{
	ASSERT(this);
	ASSERT(valid);

	return level;
}

//---------------------------------------------------------------------------
//
//	KwxƂ̃t@C擾
//
//---------------------------------------------------------------------------
const BYTE* FASTCALL FATName::GetNames(int lev) const
{
	ASSERT(this);
	ASSERT(valid);

	// x`FbN
	if (level < lev) {
		return NULL;
	}

	// xOKȂ̂ŁA͕K
	ASSERT(names[lev]);
	return names[lev];
}

//---------------------------------------------------------------------------
//
//	WideMultiϊ
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATName::ToMulti(LPCTSTR lpszWide, BYTE *lpszMulti)
{
#if defined(UNICODE)
	int length;

	// CP932T|[gĂȂ΁ASHIFT-JIS֕ϊłȂ
	if (!::Support932()) {
		return FALSE;
	}

	// xvZ
	length = _tcslen(lpszWide);

	// ϊ
	if (!::WideCharToMultiByte( 932,
								0,
								lpszWide,
								length,
								lpszMulti,
								(length + 1) * 2,
								NULL,
								NULL) == 0) {
		// UNICODECP932ւ̕ϊs
		return FALSE;
	}
#else
	// Warning
	lpszMulti = (BYTE*)lpszWide;
#endif	// UNICODE

	return TRUE;
}

//---------------------------------------------------------------------------
//
//	̃pX؂܂́AI[𒲂ׂ
//
//---------------------------------------------------------------------------
BYTE* FASTCALL FATName::GetNextSlash(BYTE *path) const
{
	ASSERT(this);
	ASSERT(path);

	// [v
	for (;;) {
		// I[́ANULLƂĕԂ
		if (*path == '\0') {
			return NULL;
		}

		// pX؂肪΁ÄʒuԂ
		if (*path == '/') {
			break;
		}

		// SHIFT-JIS 1oCgڂ
		if (IsKanji(*path)) {
			// ̎I[ȂAƂĂBNULLԂ
			if (path[1] == '\0') {
				return NULL;
			}

			// B2oCgXLbv
			path += 2;
		}
		else {
			// ASCIIB1oCgXLbv
			path++;
		}
	}

	// pX؂肪̂ŁÄʒuԂ
	return path;
}

//---------------------------------------------------------------------------
//
//	̃pX؂܂́AI[܂ŃRs[
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATName::CopyName(int lev, const BYTE *path)
{
	int length;
	const BYTE *ptr;

	ASSERT(this);
	ASSERT((lev >= 0) && (lev < LevelMax));
	ASSERT(path);

	// Rs[̃x͋󂢂Ă邱
	ASSERT(!names[lev]);

	// UA񐔂JEg
	length = 0;
	ptr = path;

	// [v
	for (;;) {
		// I[ɂȂ΁AI
		if (*ptr == '\0') {
			break;
		}

		// pX؂肪΁AI
		if (*ptr == '/') {
			break;
		}

		// SHIFT-JIS 1oCgڂ
		if (IsKanji(*ptr)) {
			// ̎I[ȂAƂĂBI
			if (ptr[1] == '\0') {
				break;
			}

			// B2oCgǉ
			ptr += 2;
			length += 2;
		}
		else {
			// ASCIIB1oCgǉ
			ptr++;
			length++;
		}
	}

	// Œ1݂͑ȂƁAȂ
	ASSERT(length > 0);
	if (length == 0) {
		return FALSE;
	}

	// m(+1)
	try {
		names[lev] = new BYTE[length + 1];
	}
	catch (...) {
		names[lev] = NULL;
	}
	if (names[lev] == NULL) {
		return FALSE;
	}

	// length͗LBŌɏI[ǉOK
	memcpy(names[lev], path, length);
	names[lev][length] = '\0';

	return TRUE;
}

//---------------------------------------------------------------------------
//
//	SHIFT-JIS 1oCgڂ̔
//
//---------------------------------------------------------------------------
BOOL FASTCALL FATName::IsKanji(BYTE c) const
{
	ASSERT(this);

	// GA1
	if ((c >= 0x80) && (c <= 0x9f)) {
		return TRUE;
	}

	// GA2
	if ((c >= 0xe0) && (c <= 0xfd)) {
		return TRUE;
	}

	// ǂłȂ
	return FALSE;
}

#endif	// _WIN32
