//---------------------------------------------------------------------------
//
//	X68000 EMULATOR "XM6" UTILITY
//
//	Copyright (C) 2001-2006 ohD(ytanaka@ipc-tokai.or.jp)
//	[ tbs[fBXNC[W ]
//
//---------------------------------------------------------------------------

#if !defined(fdi_h)
#define fdi_h

#include "filepath.h"

//---------------------------------------------------------------------------
//
//	NXs`
//
//---------------------------------------------------------------------------
class FDI;
class FDIDisk;
class FDITrack;
class FDISector;
class FDIDisk2HD;
class FDITrack2HD;

//---------------------------------------------------------------------------
//
//	G[`
//	ST1, ST2, 󂫃rbgꕔgp
//
//---------------------------------------------------------------------------
#define FDD_NOERROR			0x0000		// G[
#define FDD_EOT				0x8000		// EOTI[o[
#define FDD_DDAM			0x4000		// DDAMZN^
#define FDD_DATAERR			0x2000		// IDCRC܂̓f[^CRC(ReadID)
#define FDD_OVERRUN			0x1000		// I[o[(Xgf[^)
#define FDD_IDCRC			0x0800		// IDtB[hCRC
#define FDD_NODATA			0x0400		// LȃZN^Ȃ
#define FDD_NOTWRITE		0x0200		// ݋֎~Mo
#define FDD_MAM				0x0100		// AhX}[NȂ
#define FDD_NOTREADY		0x0080		// mbgfB
#define FDD_CM				0x0040		// DDAM܂DAMo
#define FDD_DATACRC			0x0020		// f[^CRC
#define FDD_NOCYL			0x0010		// V_قȂ
#define FDD_SCANEQ			0x0008		// SCANňv
#define FDD_SCANNOT			0x0004		// SCANňv̂Ȃ
#define FDD_BADCYL			0x0002		// V_s
#define FDD_MDAM			0x0001		// DAMȂ

//===========================================================================
//
//	FDIZN^
//
//===========================================================================
class FDISector
{
public:
	// f[^`
	typedef struct {
		DWORD chrn[4];					// CHRN
		BOOL mfm;						// MFMtO
		int error;						// G[R[h
		int length;						// f[^
		BYTE *buffer;					// f[^obt@
		DWORD pos;						// |WV
		BOOL changed;					// ύXς݃tO
		FDISector *next;				// ̃ZN^
	} sector_t;

public:
	// {t@NV
	FDISector(BOOL mfm, const DWORD *chrn);
										// RXgN^
	virtual ~FDISector();
										// fXgN^
	void FASTCALL Load(const BYTE *buf, int len, int err);
										// [h

	// [hECg
	BOOL FASTCALL IsMatch(BOOL mfm, const DWORD *chrn) const;
										// ZN^}b`邩
	void FASTCALL GetCHRN(DWORD *chrn)	const;
										// CHRN擾
	BOOL FASTCALL IsMFM() const			{ return sec.mfm; }
										// MFM
	int FASTCALL Read(BYTE *buf) const;
										// [h
	int FASTCALL Write(const BYTE *buf, BOOL deleted);
										// Cg
	int FASTCALL Fill(DWORD d);
										// tB

	// vpeB
	const BYTE* FASTCALL GetSector() const	{ return sec.buffer; }
										// ZN^f[^擾
	int FASTCALL GetLength() const		{ return sec.length; }
										// f[^擾
	int FASTCALL GetError() const		{ return sec.error; }
										// G[R[h擾

	// ύXtO
	BOOL FASTCALL IsChanged() const		{ return sec.changed; }
										// ύXtO`FbN
	void FASTCALL ClrChanged()			{ sec.changed = FALSE; }
										// ύXtO𗎂Ƃ
	void FASTCALL ForceChanged()		{ sec.changed = TRUE; }
										// ύXtOグ

	// CfbNXEN
	void FASTCALL SetNext(FDISector *next)	{ sec.next = next; }
										// ̃ZN^ݒ
	FDISector* FASTCALL GetNext() const	{ return sec.next; }
										// ̃ZN^擾

private:
	// f[^
	sector_t sec;
										// ZN^f[^
};

//===========================================================================
//
//	FDIgbN
//
//===========================================================================
class FDITrack
{
public:
	// [N
	typedef struct {
		FDIDisk *disk;					// efBXN
		int track;						// gbN
		BOOL init;						// [hς݂
		int sectors[3];					// LZN^(ALL/FM/MFM)
		BOOL hd;						// xtO
		BOOL mfm;						// 擪ZN^MFMtO
		FDISector *first;				// ŏ̃ZN^
		FDITrack *next;					// ̃gbN
	} track_t;

public:
	// {t@NV
	FDITrack(FDIDisk *disk, int track, BOOL hd = TRUE);
										// RXgN^
	virtual ~FDITrack();
										// fXgN^
	virtual BOOL FASTCALL Save(Fileio *fio, DWORD offset);
										// Z[u
	virtual BOOL FASTCALL Save(const Filepath& path, DWORD offset);
										// Z[u
	BOOL FASTCALL IsHD() const			{ return trk.hd; }
										// HDtO擾

	// [hECg
	int FASTCALL ReadSector(BYTE *buf, int *len, BOOL mfm, const DWORD *chrn);
										// [hZN^
	int FASTCALL WriteSector(const BYTE *buf, int *len, BOOL mfm, const DWORD *chrn, BOOL deleted);
										// CgZN^

	// CfbNXEN
	int FASTCALL GetTrack() const		{ return trk.track; }
										// ̃gbN擾
	void FASTCALL SetNext(FDITrack *p)	{ trk.next = p; }
										// ̃gbNݒ
	FDITrack* FASTCALL GetNext() const	{ return trk.next; }
										// ̃gbN擾

	// ZN^
	BOOL FASTCALL IsChanged() const;
										// ύXtO`FbN
	DWORD FASTCALL GetTotalLength() const;
										// ZN^OX݌vZo
	void FASTCALL ForceChanged();
										// ύX
	FDISector* FASTCALL Search(BOOL mfm, const DWORD *chrn);
										// ɍZN^T[`
	FDISector* FASTCALL GetFirst() const{ return trk.first; }
										// ŏ̃ZN^擾

protected:
	// fBXNA]Ǘ
	FDIDisk* FASTCALL GetDisk() const	{ return trk.disk; }
										// fBXN擾
	BOOL FASTCALL IsMFM() const			{ return trk.mfm; }
										// 擪ZN^MFM
	DWORD FASTCALL GetSize(FDISector *sector) const;
										// ZN^̃TCY(ID,GAP3܂)擾
	FDISector* FASTCALL GetCurSector() const;
										// Jgʒuȍ~̍ŏ̃ZN^擾

	// gbN
	BOOL IsInit() const					{ return trk.init; }

	// ZN^
	void FASTCALL AddSector(FDISector *sector);
										// ZN^ǉ
	void FASTCALL ClrSector();
										// ZN^S폜
	int FASTCALL GetAllSectors() const	{ return trk. sectors[0]; }
										// ZN^擾(All)
	int FASTCALL GetMFMSectors() const	{ return trk.sectors[1]; }
										// ZN^擾(MFM)
	int FASTCALL GetFMSectors() const	{ return trk.sectors[2]; }
										// ZN^擾(FM)

	// f[^
	track_t trk;
										// gbNf[^
};

//===========================================================================
//
//	FDIfBXN
//
//===========================================================================
class FDIDisk
{
public:
	// f[^`
	typedef struct {
		int index;						// CfbNX
		FDI *fdi;						// eFDI
		DWORD id;						// ID
		BOOL writep;					// ݋֎~
		BOOL readonly;					// ǂݍݐp
		char name[60];					// fBXN
		Filepath path;					// pX
		DWORD offset;					// t@C̃ItZbg
		FDITrack *first;				// ŏ̃gbN
		FDITrack *head[2];				// wbhɑΉgbN
		int search;						// (P=0x10000)
		FDIDisk *next;					// ̃fBXN
	} disk_t;

public:
	FDIDisk(int index, FDI *fdi);
										// RXgN^
	virtual ~FDIDisk();
										// fXgN^
	DWORD FASTCALL GetID() const		{ return disk.id; }
										// ID擾

	// fBA
	virtual BOOL FASTCALL Open(const Filepath& path, DWORD offset = 0);
										// I[v
	void FASTCALL GetName(char *buf) const;
										// fBXN擾
	void FASTCALL GetPath(Filepath& path) const;
										// pX擾
	BOOL FASTCALL IsWriteP() const		{ return disk.writep; }
										// CgveNg
	BOOL FASTCALL IsReadOnly() const	{ return disk.readonly; }
										// Read OnlyfBXNC[W
	void FASTCALL WriteP(BOOL flag);
										// ݋֎~Zbg
	virtual BOOL FASTCALL Flush();
										// obt@tbV

	// ANZX
	virtual void FASTCALL Seek(int c);
										// V[N
	int FASTCALL ReadSector(BYTE *buf, int *len, BOOL mfm, const DWORD *chrn, int hd);
										// [hZN^
	int FASTCALL WriteSector(const BYTE *buf, int *len, BOOL mfm, const DWORD *chrn, int hd, BOOL deleted);
										// CgZN^

	// 
	FDITrack* FASTCALL Search(int track) const;
										// gbNT[`

	// CfbNXEN
	int FASTCALL GetIndex() const		{ return disk.index; }
										// CfbNX擾
	void FASTCALL SetNext(FDIDisk *p)	{ disk.next = p; }
										// ̃gbNݒ
	FDIDisk* FASTCALL GetNext() const	{ return disk.next; }
										// ̃gbN擾

protected:
	// gbN
	void FASTCALL AddTrack(FDITrack *track);
										// gbNǉ
	void FASTCALL ClrTrack();
										// gbNS폜
	FDITrack* FASTCALL GetFirst() const	{ return disk.first; }
										// ŏ̃gbN擾
	FDITrack* FASTCALL GetHead(int idx) { ASSERT((idx==0)||(idx==1)); return disk.head[idx]; }
										// wbhɑΉgbN擾

	// f[^
	disk_t disk;
										// fBXNf[^
};

//===========================================================================
//
//	FDIgbN(2HD)
//
//===========================================================================
class FDITrack2HD : public FDITrack
{
public:
	// {t@NV
	FDITrack2HD(FDIDisk *disk, int track);
										// RXgN^
	BOOL FASTCALL Load(const Filepath& path, DWORD offset);
										// [h
};

//===========================================================================
//
//	FDIfBXN(2HD)
//
//===========================================================================
class FDIDisk2HD : public FDIDisk
{
public:
	FDIDisk2HD(int index, FDI *fdi);
										// RXgN^
	BOOL FASTCALL Open(const Filepath& path, DWORD offset = 0);
										// I[v
	void FASTCALL Seek(int c);
										// V[N
	BOOL FASTCALL Flush();
										// obt@tbV
};

#endif	// fdi_h
