//---------------------------------------------------------------------------
//
//	X68000 EMULATOR "XM6" UTILITY
//
//	Copyright (C) 2001-2006 ohD(ytanaka@ipc-tokai.or.jp)
//	[ MFC AvP[V ]
//
//---------------------------------------------------------------------------

#if defined(_WIN32)

#include "os.h"
#include "xm6util.h"
#include "mfc_udlg.h"
#include "mfc_uapp.h"

//---------------------------------------------------------------------------
//
//	AvP[V CX^X
//
//---------------------------------------------------------------------------
CUtilApp theUtilApp;

//---------------------------------------------------------------------------
//
//	֐|C^`
//
//---------------------------------------------------------------------------
extern "C" {
typedef int (WINAPI *DRAWTEXTWIDE)(HDC, LPCWSTR, int, LPRECT, UINT);
}

//---------------------------------------------------------------------------
//
//	X^eBbN [N
//
//---------------------------------------------------------------------------
static BOOL bJapanese;					// {EpꔻʃtO
static BOOL bWinNT;						// WindowsNTEWindows9xʃtO
static BOOL bSupport932;				// CP932(SHIFT-JIS)T|[gtO
static DRAWTEXTWIDE pDrawTextW;			// DrawTextW

//---------------------------------------------------------------------------
//
//	{̔
//
//---------------------------------------------------------------------------
BOOL FASTCALL IsJapanese(void)
{
	return bJapanese;
}

//---------------------------------------------------------------------------
//
//	WindowsNT̔
//
//---------------------------------------------------------------------------
BOOL FASTCALL IsWinNT(void)
{
	return bWinNT;
}

//---------------------------------------------------------------------------
//
//	CP932T|[g̔
//
//---------------------------------------------------------------------------
BOOL FASTCALL Support932(void)
{
	return bSupport932;
}

//---------------------------------------------------------------------------
//
//	bZ[W擾
//
//---------------------------------------------------------------------------
void FASTCALL GetMsg(UINT uID, CString& string)
{
	// uID=0Ŕłꍇ
	if (uID == 0) {
		string.Empty();
		return;
	}

	// {ꂩ
	if (IsJapanese()) {
		if (!string.LoadString(uID)) {
#if defined(_DEBUG)
			TRACE(_T("GetMsg:񃍁[hɎs ID:%d\n"), uID);
#endif	// _DEBUG
			string.Empty();
		}
		return;
	}

	// pB+5000Ŏ
	if (string.LoadString(uID + 5000)) {
		return;
	}

	// +0łx
	if (!string.LoadString(uID)) {
#if defined(_DEBUG)
		TRACE(_T("GetMsg:񃍁[hɎs ID:%d\n"), uID);
#endif	// _DEBUG
		string.Empty();
	}
}

//---------------------------------------------------------------------------
//
//	DrawTextW
//	T|[gOSł́AȂ
//
//---------------------------------------------------------------------------
int FASTCALL DrawTextWide(HDC hDC, LPCWSTR lpString, int nCount, LPRECT lpRect, UINT uFormat)
{
	// T|[gĂ邩
	if (!pDrawTextW) {
		// Ȃ
		return 1;
	}

	// ChDraw
	return pDrawTextW(hDC, lpString, nCount, lpRect, uFormat);
}

//===========================================================================
//
//	AvP[V
//
//===========================================================================

//---------------------------------------------------------------------------
//
//	RXgN^
//
//---------------------------------------------------------------------------
CUtilApp::CUtilApp() : CWinApp(_T("XM6Util"))
{
	// nhE|C^
	m_hUser32 = NULL;
	pDrawTextW = NULL;

	// 
	CheckEnvironment();
}

//---------------------------------------------------------------------------
//
//	CX^X
//
//---------------------------------------------------------------------------
BOOL CUtilApp::InitInstance()
{
	CUtilDlg dlg;

	// {NX
	if (!CWinApp::InitInstance()) {
		return FALSE;
	}

	// _CAOCEBhEɂ
	m_pMainWnd = &dlg;

	// [__CAOs
	dlg.DoModal();

	// AvP[VI
	return FALSE;
}

//---------------------------------------------------------------------------
//
//	CX^XI
//
//---------------------------------------------------------------------------
BOOL CUtilApp::ExitInstance()
{
	// USER32.DLL
	if (m_hUser32) {
		pDrawTextW = NULL;
		::FreeLibrary(m_hUser32);
		m_hUser32 = NULL;
	}

	// {NX
	return CWinApp::ExitInstance();
}

//---------------------------------------------------------------------------
//
//	̔
//
//---------------------------------------------------------------------------
void FASTCALL CUtilApp::CheckEnvironment()
{
#if _MSC_VER >= 1920
#else
	OSVERSIONINFO ovi;
#endif // _MSC_VER

	ASSERT(this);

	// {̔
	::bJapanese = FALSE;
	if (PRIMARYLANGID(GetUserDefaultUILanguage()) == LANG_JAPANESE) {
		::bJapanese = TRUE;
	}

	// WindowsNT̔
#if _MSC_VER >= 1920
	// Visual Studio 2019̏ꍇAWindows 9xœ삷oCi쐬邱Ƃ͂łȂ
	::bWinNT = TRUE;
#else
	memset(&ovi, 0, sizeof(ovi));
	ovi.dwOSVersionInfoSize = sizeof(ovi);
	VERIFY(::GetVersionEx(&ovi));
	if (ovi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
		::bWinNT = TRUE;
	}
	else {
		::bWinNT = FALSE;
	}
#endif // _MSC_VER

	// R[hy[W932T|[g̔(UNICODET|[gO)
	::bSupport932 = FALSE;
	if (::bWinNT) {
		// UNICODET|[gOS
		if (::IsValidCodePage(932)) {
			// USER32.DLL[h
			m_hUser32 = ::LoadLibrary(_T("USER32.DLL"));
			if (m_hUser32) {
				// DrawTextW̃AhX𓾂
				pDrawTextW = (DRAWTEXTWIDE)::GetProcAddress(m_hUser32, _T("DrawTextW"));
				if (pDrawTextW) {
					// CP932ւ̕ϊƕ\\
					::bSupport932 = TRUE;
				}
			}
		}
	}
}

#endif	// _WIN32
