//---------------------------------------------------------------------------
//
//	X68000 EMULATOR "XM6"
//
//	Copyright (C) 2001-2006 ohD(ytanaka@ipc-tokai.or.jp)
//	[ MFC [eBeB_CAO ]
//
//---------------------------------------------------------------------------

#if defined(_WIN32)

#include "os.h"
#include "xm6util.h"
#include "cgrom.h"
#include "scsirom.h"
#include "resource.h"
#include "mfc_uabt.h"
#include "mfc_uipl.h"
#include "mfc_ucg.h"
#include "mfc_uscs.h"
#include "mfc_utky.h"
#include "mfc_udlg.h"

//===========================================================================
//
//	[eBeB_CAO
//
//===========================================================================

//---------------------------------------------------------------------------
//
//	RXgN^
//
//---------------------------------------------------------------------------
CUtilDlg::CUtilDlg(CWnd *pParent) : CDialog(IDD_UTIL_DLG, pParent)
{
	// ACR[h
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// o[W
	m_dwMajor = 0;
	m_dwMinor = 0;
}

//---------------------------------------------------------------------------
//
//	bZ[W }bv
//
//---------------------------------------------------------------------------
BEGIN_MESSAGE_MAP(CUtilDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_UTIL_IPLB, OnIPL)
	ON_BN_CLICKED(IDC_UTIL_CGB, OnCG)
	ON_BN_CLICKED(IDC_UTIL_SCSIIB, OnSCSIInt)
	ON_BN_CLICKED(IDC_UTIL_SCSIEB, OnSCSIExt)
	ON_BN_CLICKED(IDC_UTIL_TKEYB, OnTrueKey)
END_MESSAGE_MAP()

//---------------------------------------------------------------------------
//
//	_CAO
//
//---------------------------------------------------------------------------
BOOL CUtilDlg::OnInitDialog()
{
	CMenu *pSysMenu;
	CString strAboutMenu;
	TCHAR szPath[_MAX_PATH];
	VS_FIXEDFILEINFO *pFileInfo;
	DWORD dwHandle;
	DWORD dwLength;
	BYTE *pVerInfo;
	UINT uLength;

	// {NX
	if (!CDialog::OnInitDialog()) {
		return FALSE;
	}

	// o[WVXej[ɒǉ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu) {
		::GetMsg(IDS_ABOUTBOX, strAboutMenu);
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// ACRݒ
	SetIcon(m_hIcon, TRUE);

	// o[W擾
	::GetModuleFileName(NULL, szPath, _MAX_PATH);
	dwLength = GetFileVersionInfoSize(szPath, &dwHandle);
	if (dwLength != 0) {
		// m
		pVerInfo = new BYTE[ dwLength ];

		// ǂݏo
		if (::GetFileVersionInfo(szPath, dwHandle, dwLength, pVerInfo)) {
			// o[Wo
			if (::VerQueryValue(pVerInfo, _T("\\"), (LPVOID*)&pFileInfo, &uLength)) {
				// W[o[Wƃ}Ci[o[W쐬
				m_dwMajor = (DWORD)HIWORD(pFileInfo->dwProductVersionMS);
				m_dwMinor = (DWORD)(LOWORD(pFileInfo->dwProductVersionMS) * 16
							+ HIWORD(pFileInfo->dwProductVersionLS));
			}
		}

		// 
		delete[] pVerInfo;
	}

	return TRUE;
}

//---------------------------------------------------------------------------
//
//	OK
//
//---------------------------------------------------------------------------
void CUtilDlg::OnOK()
{
	// [ENTER]ɂI}
}

//---------------------------------------------------------------------------
//
//	`
//
//---------------------------------------------------------------------------
void CUtilDlg::OnPaint()
{
	// ŏĂȂ΁A{NX֗
	if (!IsIconic()) {
		CDialog::OnPaint();
	}

	// ŏĂ̂ŁAACR`
	if (m_hIcon) {
		PaintIcon();
	}
}

//---------------------------------------------------------------------------
//
//	ACR`
//
//---------------------------------------------------------------------------
void FASTCALL CUtilDlg::PaintIcon()
{
	CPaintDC dc(this);
	int cxIcon;
	int cyIcon;
	CRect rect;
	int x;
	int y;

	// ACR̔wi`(SendMessageɂAŊ)
	SendMessage(WM_ICONERASEBKGND, (WPARAM)(dc.GetSafeHdc()), 0);

	// NCAg̎lp`̈̒
	cxIcon = GetSystemMetrics(SM_CXICON);
	cyIcon = GetSystemMetrics(SM_CYICON);

	// NCAg`AACR̕\ʒuZo
	GetClientRect(&rect);
	x = (rect.Width() - cxIcon + 1) / 2;
	y = (rect.Height() - cyIcon + 1) / 2;

	// ACR`
	dc.DrawIcon(x, y, m_hIcon);
}

//---------------------------------------------------------------------------
//
//	VXeR}h
//
//---------------------------------------------------------------------------
void CUtilDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	CAboutDlg dlg;

	// o[W\ׂ
	if ((nID & 0xFFF0) == IDM_ABOUTBOX) {
		// o[W\
		dlg.DoModal();
		return;
	}

	// {NX
	CDialog::OnSysCommand(nID, lParam);
}

//---------------------------------------------------------------------------
//
//	ŏꂽ_CAO[UɂhbOĂƂ
//	ACR
//
//---------------------------------------------------------------------------
HCURSOR CUtilDlg::OnQueryDragIcon()
{
	return (HCURSOR)m_hIcon;
}

//---------------------------------------------------------------------------
//
//	IPL-ROM
//
//---------------------------------------------------------------------------
void CUtilDlg::OnIPL()
{
	CIPLDlg dlg;

	dlg.DoModal();
}

//---------------------------------------------------------------------------
//
//	CG-ROM
//
//---------------------------------------------------------------------------
void CUtilDlg::OnCG()
{
	CCGDlg dlg;
	CGROM cg;
	Filepath path;
	BOOL bFont;
	BOOL bSuccess;
	CString strMsg;

	// _CAO\
	if (dlg.DoModal() != IDOK) {
		return;
	}

	// 쐬
	path.SysFile(Filepath::CGTMP);
	bFont = cg.Init();
	if (!bFont) {
		::GetMsg(IDS_NO_FONT, strMsg);
		MessageBox(strMsg, NULL, MB_ICONSTOP | MB_OK);
		cg.Cleanup();
		return;
	}

	// 쐬
	AfxGetApp()->BeginWaitCursor();
	bSuccess = cg.Create(path, (m_dwMajor << 8) | m_dwMinor);
	cg.Cleanup();
	AfxGetApp()->EndWaitCursor();

	// ʕ\
	if (bSuccess) {
		::GetMsg(IDS_CGROM_SUCCESS, strMsg);
		MessageBox(strMsg, NULL, MB_ICONINFORMATION | MB_OK);
	}
	else {
		::GetMsg(IDS_CGROM_ERR, strMsg);
		MessageBox(strMsg, NULL, MB_ICONSTOP | MB_OK);
	}
}

//---------------------------------------------------------------------------
//
//	SCSI-ROM()
//
//---------------------------------------------------------------------------
void CUtilDlg::OnSCSIInt()
{
	CSCSIDlg dlg;
	SCSIROM sc;
	BOOL bFile;
	BOOL bSuccess;
	CString strMsg;

	// _CAO\
	if (dlg.DoModal() != IDOK) {
		return;
	}

	// 쐬
	bFile = sc.Init();
	if (!bFile) {
		::GetMsg(IDS_SCSIROM_NOXDF, strMsg);
		MessageBox(strMsg, NULL, MB_ICONSTOP | MB_OK);
		sc.Cleanup();
		return;
	}

	// 쐬
	AfxGetApp()->BeginWaitCursor();
	bSuccess = sc.Create(FALSE, (m_dwMajor << 8) | m_dwMinor);
	sc.Cleanup();
	AfxGetApp()->EndWaitCursor();

	// ʕ\
	if (bSuccess) {
		::GetMsg(IDS_SCSIROM_SUCI, strMsg);
		MessageBox(strMsg, NULL, MB_ICONINFORMATION | MB_OK);
	}
	else {
		::GetMsg(IDS_SCSIROM_ERR, strMsg);
		MessageBox(strMsg, NULL, MB_ICONSTOP | MB_OK);
	}
}

//---------------------------------------------------------------------------
//
//	SCSI-ROM(Ot)
//
//---------------------------------------------------------------------------
void CUtilDlg::OnSCSIExt()
{
	CSCSIDlg dlg;
	SCSIROM sc;
	BOOL bFile;
	BOOL bSuccess;
	CString strMsg;

	// _CAO\
	if (dlg.DoModal() != IDOK) {
		return;
	}

	// 쐬
	bFile = sc.Init();
	if (!bFile) {
		::GetMsg(IDS_SCSIROM_NOXDF, strMsg);
		MessageBox(strMsg, NULL, MB_ICONSTOP | MB_OK);
		sc.Cleanup();
		return;
	}

	// 쐬
	AfxGetApp()->BeginWaitCursor();
	bSuccess = sc.Create(TRUE, (m_dwMajor << 8) | m_dwMinor);
	sc.Cleanup();
	AfxGetApp()->EndWaitCursor();

	// ʕ\
	if (bSuccess) {
		::GetMsg(IDS_SCSIROM_SUCE, strMsg);
		MessageBox(strMsg, NULL, MB_ICONINFORMATION | MB_OK);
	}
	else {
		::GetMsg(IDS_SCSIROM_ERR, strMsg);
		MessageBox(strMsg, NULL, MB_ICONSTOP | MB_OK);
	}
}

//---------------------------------------------------------------------------
//
//	TrueKey
//
//---------------------------------------------------------------------------
void CUtilDlg::OnTrueKey()
{
	CTKeyDlg dlg;

	dlg.DoModal();
}

#endif	// _WIN32
