//---------------------------------------------------------------------------
//
//	X68000 EMULATOR "XM6" UTILITY
//
//	Copyright (C) 2001-2006 ohD(ytanaka@ipc-tokai.or.jp)
//	[ MFC TrueKey_CAO ]
//
//---------------------------------------------------------------------------

#if defined(_WIN32)

#include "os.h"
#include "xm6util.h"
#include "truekey.h"
#include "resource.h"
#include "mfc_utky.h"

//===========================================================================
//
//	TrueKey_CAO
//
//===========================================================================

//---------------------------------------------------------------------------
//
//	RXgN^
//
//---------------------------------------------------------------------------
CTKeyDlg::CTKeyDlg(CWnd *pParent) : CDialog(IDD_TRUEKEY_DLG, pParent)
{
	// IuWFNgȂ
	m_pTrueKey = NULL;

	// IuWFNg
	m_bValid = FALSE;
}

//---------------------------------------------------------------------------
//
//	bZ[W }bv
//
//---------------------------------------------------------------------------
BEGIN_MESSAGE_MAP(CTKeyDlg, CDialog)
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
END_MESSAGE_MAP()

//---------------------------------------------------------------------------
//
//	_CAO
//
//---------------------------------------------------------------------------
BOOL CTKeyDlg::OnInitDialog()
{
	int cx, cy;
	CStatic *pStatic;
	CRect rectWnd;

	// {NX
	if (!CDialog::OnInitDialog()) {
		return FALSE;
	}

	// TrueKey쐬
	m_pTrueKey = new TrueKey;

	// 
	m_bValid = m_pTrueKey->Init();
	if (!m_bValid) {
		// sȂ_CAO𑦍ɃN[Y
		PostMessage(WM_COMMAND, IDCANCEL, 0);
		return TRUE;
	}

	// rbg}bṽTCY擾
	cx = m_pTrueKey->GetWidth();
	cy = m_pTrueKey->GetHeight();

	// X^eBbN`擾
	pStatic = (CStatic*)GetDlgItem(IDC_TRUEKEY_STATIC);
	ASSERT(pStatic);
	pStatic->GetWindowRect(&m_rectBitmap);

	// `ƃEBhETCYg
	GetWindowRect(&rectWnd);
	rectWnd.right += (cx - m_rectBitmap.Width());
	rectWnd.bottom += (cy - m_rectBitmap.Height());
	SetWindowPos(&wndTop, 0, 0, rectWnd.Width(), rectWnd.Height(), SWP_NOMOVE);
	m_rectBitmap.right += (cx - m_rectBitmap.Width());
	m_rectBitmap.bottom += (cy - m_rectBitmap.Height());
	pStatic->SetWindowPos(&wndTop, 0, 0, m_rectBitmap.Width(), m_rectBitmap.Height(), SWP_NOMOVE);

	// `폜
	pStatic = (CStatic*)GetDlgItem(IDC_TRUEKEY_STATIC);
	ASSERT(pStatic);
	pStatic->GetWindowRect(&m_rectBitmap);
	ScreenToClient(&m_rectBitmap);
	pStatic->DestroyWindow();

	// eEBhE̒Sֈړ
	CenterWindow();

	// I
	return TRUE;
}

//---------------------------------------------------------------------------
//
//	EBhE폜
//
//---------------------------------------------------------------------------
void CTKeyDlg::OnDestroy()
{
	// TrueKey΁A폜
	if (m_pTrueKey) {
		m_pTrueKey->Cleanup();
		delete m_pTrueKey;
		m_pTrueKey = NULL;
	}

	// {NX
	CDialog::OnDestroy();
}

//---------------------------------------------------------------------------
//
//	`
//
//---------------------------------------------------------------------------
void CTKeyDlg::OnPaint()
{
	CPaintDC dc(this);
	CRect rect;
	BYTE bmpinfo[sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 2];
	BITMAPINFOHEADER *pbmi;
	RGBQUAD *prgb;

	// `FbN(1)
	if (!m_bValid) {
		GetClientRect(&rect);
		dc.FillSolidRect(&rect, ::GetSysColor(COLOR_3DFACE));
		return;
	}

	// `FbN(2)
	ASSERT(m_pTrueKey);
	if (m_pTrueKey->GetBitCount() != 1) {
		dc.FillSolidRect(&m_rectBitmap, ::GetSysColor(COLOR_3DFACE));
		return;
	}

	// PFrbg}bvȂ̂ŁAwb_\z
	pbmi = (BITMAPINFOHEADER*)&bmpinfo[0];
	memset(pbmi, 0, sizeof(BITMAPINFOHEADER));
	pbmi->biSize = sizeof(BITMAPINFOHEADER);
	pbmi->biWidth = m_pTrueKey->GetWidth();
	pbmi->biHeight = m_pTrueKey->GetHeight();
	pbmi->biPlanes = 1;
	pbmi->biBitCount = 1;
	pbmi->biCompression = BI_RGB;
	pbmi->biSizeImage = (((pbmi->biWidth / 8 + 3) >> 2) << 2) * pbmi->biHeight;

	// J[e[u쐬
	prgb = (RGBQUAD*)&bmpinfo[sizeof(BITMAPINFOHEADER)];
	prgb[0].rgbBlue = 0;
	prgb[0].rgbGreen = 0;
	prgb[0].rgbRed = 0;
	prgb[0].rgbReserved = 0;
	prgb[1].rgbBlue = 0xff;
	prgb[1].rgbGreen = 0xff;
	prgb[1].rgbRed = 0xff;
	prgb[1].rgbReserved = 0;

	// SetDIBitsToDeviceŕ`
	::SetDIBitsToDevice(dc.m_hDC, m_rectBitmap.left, m_rectBitmap.top,
						pbmi->biWidth, pbmi->biHeight,
						0, 0, 0, pbmi->biHeight,
						m_pTrueKey->GetBits(), (BITMAPINFO*)&bmpinfo[0], DIB_RGB_COLORS);
}

//---------------------------------------------------------------------------
//
//	}EX{^
//
//---------------------------------------------------------------------------
void CTKeyDlg::OnLButtonDown(UINT /*nFlags*/, CPoint /*point*/)
{
	// _CAO
	EndDialog(IDCANCEL);
}

//---------------------------------------------------------------------------
//
//	}EXE{^
//
//---------------------------------------------------------------------------
void CTKeyDlg::OnRButtonDown(UINT /*nFlags*/, CPoint /*point*/)
{
	// _CAO
	EndDialog(IDCANCEL);
}

#endif	// _WIN32
